/**
 * Created by janis dähne.
 */
import * as genericLayer from './genericLayer'
import {CustomProjectPreviewFullBase} from "../types/customProjects";

const callingName = 'customProjectOverviewLayer'
const controllerPrefix = 'custom/projects/overview'

export async function getOwnCustomProjectOverviews(): Promise<ReadonlyArray<CustomProjectPreviewFullBase>> {
  return genericLayer.get<ReadonlyArray<CustomProjectPreviewFullBase>>(callingName,
    `${controllerPrefix}/all`)
}

export async function deleteOwnCustomProject(customProjectPreview: CustomProjectPreviewFullBase): Promise<void> {
  return genericLayer.del<void>(callingName,
    `${controllerPrefix}/delete/${customProjectPreview.id}`)
}