/**
 * Created by janis dähne.
 */

import * as genericLayer from './genericLayer'
import {CustomProjectFullBase} from "../types/customProjects";
import {
  ClientServerSettings, HardwareUsageStatistic, LogicalUsageStatistic,
  TestServerSettings
} from "../types/dashboard";


const callingName = 'dashboardLayer'
const controllerPrefix = 'dashboard'


export async function getHardwareUsage(): Promise<HardwareUsageStatistic> {
  return genericLayer.get<HardwareUsageStatistic>(callingName,
    `${controllerPrefix}/hardware/usage`)
}

export async function getLogicalUsage(): Promise<LogicalUsageStatistic> {
  return genericLayer.get<LogicalUsageStatistic>(callingName,
    `${controllerPrefix}/logical/usage`)
}

export async function getClientServerSettings(): Promise<ClientServerSettings> {
  return genericLayer.get<ClientServerSettings>(callingName,
    `${controllerPrefix}/server/settings`)
}


export async function getTestServerSettings(): Promise<TestServerSettings> {
  return genericLayer.get<TestServerSettings>(callingName,
    `${controllerPrefix}/testserver/settings`)
}

