/**
 * Created by janis dähne.
 */

import * as genericLayer from './genericLayer'
import {GroupRoleWithPermissionFullBase} from "../types/groupRoles";
import {ExerciseReleaseFromBackend} from "../types/exerciseRelease";
import {SubmissionTuple} from "../types/submissions";

const callingName = 'submissionsLayer'
const controllerPrefix = 'submissions'


//TODO maybe use release id??
export async function getFromRelease(releaseCode: string, getPreAssessmentResults: boolean | null = null): Promise<SubmissionTuple> {

  return genericLayer.get<SubmissionTuple>(
    callingName, `${controllerPrefix}/${releaseCode}/${getPreAssessmentResults}`
  )
}

//TODO maybe use release id??
/**
 * rereuns all assessment (for a a release)
 * @param {string} releaseCode
 * @returns {Promise<boolean>}
 */
export async function rerunAutomaticAssessment(releaseCode: string): Promise<boolean> {
  return genericLayer.update<string, boolean>(callingName,
    `${controllerPrefix}/rerun/${releaseCode}`, '')
}

/**
 * rereuns a single assessment (for a single solution)
 * @param {string} releaseCode
 * @param {number} userId
 * @param {number} pLangId
 * @returns {Promise<boolean>}
 */
export async function rerunSingleAutomaticAssessment(releaseCode: string, userId: number, pLangId: number): Promise<boolean> {
  return genericLayer.update<string, boolean>(callingName,
    `${controllerPrefix}/rereunsingle/${releaseCode}/${userId}/${pLangId}`,
    '')
}