/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../state/reducers/index";

import SimpleAceEditor from './aceEditors/simpleAceEditor'
import {EditorTab} from "./multiTabCodeEditorProps";

//const css = require('./styles.styl');

export interface SimpleCodeEditorProps {
  //readonly test: string
  /**
   * a unique id for the editor
   */
  readonly id: string

  /**
   * a fake tab (to store a session)
   */
  readonly editorTab: EditorTab
  readonly onChange: ((editorTab: EditorTab) => void) | null //e.g. for readonly editor
  /**
   * the element used to check if the size changed and if the editor should update it's size
   */
  readonly resizeAnchorId: string

  readonly onEditorSessionChanged: ((editorTab: EditorTab) => void) | null

  readonly height?: string
}

const mapStateToProps = (rootState: RootState, props: SimpleCodeEditorProps) => {
  return {
    //test0: rootState...
    //test: props.test
    ...props
  }
}

//use this to quickly switch between monaco and ace editor
//BUT we only use ace now...
//BUT when we want to ever change the editor we only need it here!
//  because they use the same props everything (mostly) should be working...

const mapDispatchToProps = (dispatch: Dispatch<any>) => bindActionCreators({
  //imported reducer funcs here

}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

class simpleCodeEditorWrapper extends React.Component<Props, any> {
  render(): JSX.Element {
    return (
      <SimpleAceEditor
        {...this.props}
      />
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(simpleCodeEditorWrapper)