/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../state/reducers/index";
import FullSiteDialog from '../fullSiteDialog'
import EditorSettingsView from './editorSettingsView'
import {
  applyChangedEditorSettingsDialogAsync,
  cancelEditorSettingsDialog
} from "../../state/actions/editorSettingsDialog/editorSettingsDialogActions";
import {translate} from "../../../i18n/translationHelper";
import {TranslateIds} from "../../../i18n/ids";

//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string
}

const mapStateToProps = (rootState: RootState /*, props: MyProps*/) => {
  return {
    //test0: rootState...
    //test: props.test
    userSettings: rootState.userDataSettingsSate.userData.settings
      ? rootState.userDataSettingsSate.userData.settings
      : null,
    editorSettings: rootState.editorSettingsDialogState.editorSettings,
    isValid: rootState.editorSettingsDialogState.isValid,
    isBusy: rootState.editorSettingsDialogState.isBusy || rootState.userDataSettingsSate.isLoadingMiscSettings,
    setIsDialogDisplayedActionCallback: rootState.editorSettingsDialogState.setIsDialogDisplayedActionCallback
  }
}

const mapDispatchToProps = (dispatch: Dispatch<any>) => bindActionCreators({
  //imported reducer funcs here
  cancelEditorSettingsDialog,
  applyChangedEditorSettingsDialogAsync
}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

class editorSettingsDialog extends React.Component<Props, any> {
  render(): JSX.Element {
    return (
      <FullSiteDialog
        isBusy={this.props.isBusy}
        isValid={this.props.isValid}
        caption={
          <h2>
            {translate(TranslateIds.change_editor_settings)}
          </h2>
        }

        onSave={() => {
          this.props.applyChangedEditorSettingsDialogAsync(this.props.editorSettings, this.props.userSettings, this.props.setIsDialogDisplayedActionCallback)
        }}

        onCancel={() => {
          this.props.cancelEditorSettingsDialog(this.props.setIsDialogDisplayedActionCallback)
        }}
      >
        <EditorSettingsView/>
      </FullSiteDialog>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(editorSettingsDialog)