/**
 * Created by janis dähne.
 */

import * as React from "react";
import {Icon, Popup, PopupProps, SemanticICONS} from "semantic-ui-react";
import {leftIconPopupOffset} from "../../constants";
import {CSSProperties} from "react";

//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string
  readonly defaultContent: string | JSX.Element
  /**
   * the default icon is the question circle icon
   */
  readonly icon?: string

  /**
   * stylue will be applied to the icon
   */
  readonly style?: CSSProperties

  /**
   * class names are applied to the wrapping div
   */
  readonly className?: string
}

export const HelpPopupHtmlContent: React.SFC<any> = (props: MyProps & PopupProps) => {

  const {defaultContent, icon, style, className, ...popupProps} = props

  return (
    <div style={{display: 'inline-block'}} className={className}>
      <Popup
        trigger={
          <Icon className="hoverable" name={icon ? icon as SemanticICONS : 'question circle'} style={style} />
        }
        offset={leftIconPopupOffset}
        {...popupProps}
      >
        <Popup.Content>
          {
            defaultContent
          }
        </Popup.Content>
      </Popup>
    </div>
  )
}