/**
 * Created by janis dähne.
 */

///<reference path="../../../global.d.ts"/>

import * as React from "react";
import {Icon} from "semantic-ui-react";
import {PanelViewSize} from "../panelGrid/panelGrid";

interface MyProps {
  readonly panelViewSize: PanelViewSize
  readonly onSizeChangedClicked: (size: PanelViewSize) => void
}

export default class PanelHeaderControls extends React.Component<MyProps, any> {

  render(): JSX.Element {
    return (
      <div className="panel-header-items">

        <div
          className={this.props.panelViewSize === PanelViewSize.horizontalFullSized ? 'clickable-toggled' : 'clickable'}
          onClick={() => {
            if (this.props.panelViewSize === PanelViewSize.horizontalFullSized) {
              this.props.onSizeChangedClicked(PanelViewSize.normal)
            } else {
              this.props.onSizeChangedClicked(PanelViewSize.horizontalFullSized)
            }
          }}
        >
          <Icon name="resize horizontal"></Icon>
        </div>

        <div
          className={this.props.panelViewSize === PanelViewSize.verticalFullSized ? 'clickable-toggled' : 'clickable'}
          onClick={() => {

            if (this.props.panelViewSize === PanelViewSize.verticalFullSized) {
              this.props.onSizeChangedClicked(PanelViewSize.normal)
            } else {
              this.props.onSizeChangedClicked(PanelViewSize.verticalFullSized)
            }

          }}
        >
          <Icon name="resize vertical"></Icon>
        </div>

        <div className={this.props.panelViewSize === PanelViewSize.fullSized ? 'clickable-toggled' : 'clickable'}
             onClick={() => {

               if (this.props.panelViewSize === PanelViewSize.fullSized) {
                 this.props.onSizeChangedClicked(PanelViewSize.normal)
               } else {
                 this.props.onSizeChangedClicked(PanelViewSize.fullSized)
               }

             }}
        >
          <Icon name="expand arrows alternate"></Icon>
        </div>
      </div>
    )
  }
}


