/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../state/reducers/index";
import {MyProps} from './renderWrapper'
import {createAndRefreshAssetUrlsAndObjects, getObjectUrlForAsset} from "../../helpers/assetHelper";
import Logger from "../../helpers/logger";

//const css = require('./styles.styl');

const mapStateToProps = (rootState: RootState , props: MyProps) => {
  return {
    //test0: rootState...
    //test: props.test
    contentType: props.contentType,
    content: props.content,
    assets: props.assets,
    dummy: props.dummy,
  }
}

const mapDispatchToProps = (dispatch: Dispatch<any>) => bindActionCreators({
  //imported reducer funcs here

}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

class pdfRenderer extends React.Component<Props, any> {

  mapAssetUrlFilter(assetUrl:string):string {
    //this should be the displayContentControl

    // noinspection TsLint
    for (let i = 0; i < this.props.assets.length; i++) {
      const asset = this.props.assets[i];

      if (asset.assetUrl === assetUrl) {
        return getObjectUrlForAsset(asset)
      }
    }
    return ''
  }

  render(): JSX.Element {

    Logger.debug("pdfRenderer", "rendering...")

    return (
      <div className="fh">
        <embed id="display-content-pdf" width="100%" height="100%" src={this.mapAssetUrlFilter(this.props.content)} />
      </div>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(pdfRenderer)