/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../state/reducers/index";
import {Route, withRouter} from "react-router";
import * as constants from '../../constants'
import {Link} from "react-router-dom";
import {Icon} from "semantic-ui-react";
import {translate} from "../../../i18n/translationHelper";
import {TranslateIds} from "../../../i18n/ids";

//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string
}

const mapStateToProps = (rootState: RootState /*, props: MyProps*/) => {
  return {
    //test0: rootState...
    //test: props.test
    systemRole: rootState.userDataSettingsSate.userData
    && rootState.userDataSettingsSate.userData.systemRole
      ? rootState.userDataSettingsSate.userData.systemRole
      : null,
  }
}

const mapDispatchToProps = (dispatch: Dispatch<any>) => bindActionCreators({
  //imported reducer funcs here

}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

class RelatedLinksView extends React.Component<Props, any> {
  render(): JSX.Element {
    return (
      <div>

        {
          //-------- exercises stuff
        }
        <Route exact path={constants.openExercisesLinkPath} component={() =>
          <div className="related-links">
            <div>
              <Icon name="unlock"/>
              <span>
                {
                  translate(TranslateIds.allOpenExercises)
                }
              </span>
            </div>
            <Link to={constants.closedExercisesLinkPath}>
              <Icon name="lock"/>
              <span>
                {
                  translate(TranslateIds.allClosedExercises)
                }
              </span>
            </Link>
            <Link to={constants.ownExercisesLinkPath}>
              <span>
                {
                  translate(TranslateIds.ownExercises)
                }
              </span>
            </Link>
            <Link to={constants.groupExercisesLinkPath}>
              <span>
                {
                  translate(TranslateIds.groupExercises)
                }
              </span>
            </Link>
          </div>
        }/>

        <Route exact path={constants.closedExercisesLinkPath} component={() =>
          <div className="related-links">
            <Link to={constants.openExercisesLinkPath}>
              <Icon name="unlock"/>
              <span>
                {
                  translate(TranslateIds.allOpenExercises)
                }
              </span>
            </Link>
            <div>
              <Icon name="lock"/>
              <span>
                {
                  translate(TranslateIds.allClosedExercises)
                }
              </span>
            </div>
            <Link to={constants.ownExercisesLinkPath}>
              <span>
                {
                  translate(TranslateIds.ownExercises)
                }
              </span>
            </Link>
            <Link to={constants.groupExercisesLinkPath}>
              <span>
                {
                  translate(TranslateIds.groupExercises)
                }
              </span>
            </Link>
          </div>
        }/>


        <Route exact path={constants.ownExercisesLinkPath} component={() =>
          <div className="related-links">
            <Link to={constants.openExercisesLinkPath}>
              <Icon name="unlock"/>
              <span>
                {
                  translate(TranslateIds.allOpenExercises)
                }
              </span>
            </Link>
            <Link to={constants.closedExercisesLinkPath}>
              <Icon name="lock"/>
              <span>
                {
                  translate(TranslateIds.allClosedExercises)
                }
              </span>
            </Link>
            <div>
              <span>
                {
                  translate(TranslateIds.ownExercises)
                }
              </span>
            </div>
            <Link to={constants.groupExercisesLinkPath}>
              <span>
                {
                  translate(TranslateIds.groupExercises)
                }
              </span>
            </Link>
          </div>
        }/>

        <Route exact path={constants.groupExercisesLinkPath} component={() =>
          <div className="related-links">
            <Link to={constants.openExercisesLinkPath}>
              <Icon name="unlock"/>
              <span>
                {
                  translate(TranslateIds.allOpenExercises)
                }
              </span>
            </Link>
            <Link to={constants.closedExercisesLinkPath}>
              <Icon name="lock"/>
              <span>
                {
                  translate(TranslateIds.allClosedExercises)
                }
              </span>
            </Link>
            <Link to={constants.ownExercisesLinkPath}>
              <span>
                {
                  translate(TranslateIds.ownExercises)
                }
              </span>
            </Link>
            <div>
              <span>
                {
                  translate(TranslateIds.groupExercises)
                }
              </span>
            </div>
          </div>
        }/>

        {
          //-------- groups stuff
        }
        <Route exact path={constants.groupsLinkPath} component={() =>
          <div className="related-links">
            <div>
              <span>
                {
                  translate(TranslateIds.groups)
                }
              </span>
            </div>

            {
              (this.props.systemRole &&
                (this.props.systemRole.canCreateRoles
                  || this.props.systemRole.canChangeRoles
                  || this.props.systemRole.canDeleteRoles)
              ) &&
              <Link to={constants.groupRolesLinkPath}>
              <span>
                {
                  translate(TranslateIds.groupRoles)
                }
              </span>
              </Link>
            }

          </div>
        }/>

        <Route exact path={constants.groupRolesLinkPath} component={() =>
          <div className="related-links">
            <Link to={constants.groupsLinkPath}>
              <span>
                {
                  translate(TranslateIds.groups)
                }
              </span>
            </Link>
            {
              (this.props.systemRole &&
                (this.props.systemRole.canCreateRoles
                  || this.props.systemRole.canChangeRoles
                  || this.props.systemRole.canDeleteRoles)
              ) &&
              <div>
                <span>
                  {
                    translate(TranslateIds.groupRoles)
                  }
                </span>
              </div>
            }

          </div>
        }/>

        {
          //-------- system & user
        }

        <Route exact path={constants.manageNewUsersLinkPath} component={() =>
          <div className="related-links">
            {
              (this.props.systemRole && this.props.systemRole.canManageNewUsers) &&
              <div>
                <span>
                  {
                    translate(TranslateIds.manageNewUsers)
                  }
                </span>
              </div>
            }

            {
              (this.props.systemRole && (this.props.systemRole.canChangeUserData
                  || this.props.systemRole.canDeleteActivatedUsers)
              ) &&
              <Link to={constants.manageActivatedUsersLinkPath}>
              <span>
                {
                  translate(TranslateIds.manageActivatedUsers)
                }
              </span>
              </Link>
            }

            {
              (this.props.systemRole &&
                (this.props.systemRole.canCreateRoles
                  || this.props.systemRole.canChangeRoles
                  || this.props.systemRole.canDeleteRoles)
              ) &&
              <Link to={constants.systemRolesLinkPath}>
              <span>
                {
                  translate(TranslateIds.systemRoles)
                }
              </span>
              </Link>
            }

          </div>
        }/>

        <Route exact path={constants.manageActivatedUsersLinkPath} component={() =>
          <div className="related-links">
            {
              (this.props.systemRole && this.props.systemRole.canManageNewUsers) &&
              <Link to={constants.manageNewUsersLinkPath}>
              <span>
                {
                  translate(TranslateIds.manageNewUsers)
                }
              </span>
              </Link>
            }

            {
              (this.props.systemRole && (this.props.systemRole.canChangeUserData
                  || this.props.systemRole.canDeleteActivatedUsers)
              ) &&
              <div>
              <span>
                {
                  translate(TranslateIds.manageActivatedUsers)
                }
              </span>
              </div>
            }

            {
              (this.props.systemRole &&
                (this.props.systemRole.canCreateRoles
                  || this.props.systemRole.canChangeRoles
                  || this.props.systemRole.canDeleteRoles)
              ) &&
              <Link to={constants.systemRolesLinkPath}>
                <span>
                  {
                    translate(TranslateIds.systemRoles)
                  }
                </span>
              </Link>
            }

          </div>
        }/>

        <Route exact path={constants.systemRolesLinkPath} component={() =>
          <div className="related-links">
            {
              (this.props.systemRole && this.props.systemRole.canManageNewUsers) &&
              <Link to={constants.manageNewUsersLinkPath}>
              <span>
                {
                  translate(TranslateIds.manageNewUsers)
                }
              </span>
              </Link>
            }

            {
              (this.props.systemRole && (this.props.systemRole.canChangeUserData
                || this.props.systemRole.canDeleteActivatedUsers)
              ) &&
              <Link to={constants.manageActivatedUsersLinkPath}>
              <span>
                {
                  translate(TranslateIds.manageActivatedUsers)
                }
              </span>
              </Link>
            }

            {
              (this.props.systemRole &&
                (this.props.systemRole.canCreateRoles
                  || this.props.systemRole.canChangeRoles
                  || this.props.systemRole.canDeleteRoles)
              ) &&
              <div>
                <span>
                  {
                    translate(TranslateIds.systemRoles)
                  }
                </span>
              </div>
            }

          </div>
        }/>


      </div>
    )
  }
}

export default withRouter(connect(mapStateToProps, mapDispatchToProps)(RelatedLinksView))