/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../../../state/reducers/index";
import ClosedExercisesSiteViaCode from './closedExercisesSiteViaCode'
import ClosedExercisesSiteViaVisibility from './closedExercisesSiteViaVisibility'
import TagFilterPanel from '../../../tagComponents/tagFilterPanel'

//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string
}

const mapStateToProps = (rootState: RootState /*, props: MyProps*/) => {
  return {
    //test0: rootState...
    //test: props.test
    isLoading: rootState.closedExercisesState.isLoading
    || rootState.manageTagsState.isLoading,


    isTagsFilterDisplayed: rootState.closedExercisesState.isTagsFilterDisplayed,
    tags: rootState.manageTagsState.tags,
  }
}

const mapDispatchToProps = (dispatch: Dispatch<any>) => bindActionCreators({
  //imported reducer funcs here

}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

class allOpenExercisesSite extends React.Component<Props, any> {
  render(): JSX.Element {

    return (
      <div className="multiple-single-panels">

        {
          this.props.isTagsFilterDisplayed &&
          <TagFilterPanel
            isLoading={this.props.isLoading}
            allTags={this.props.tags}
          />
        }


        <ClosedExercisesSiteViaCode shouldLoadData={true} canDisplayTagFilterPanel={false}/>

        <ClosedExercisesSiteViaVisibility shouldLoadData={false} canDisplayTagFilterPanel={false}/>

      </div>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(allOpenExercisesSite)