/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../../state/reducers/index";
import {RouteComponentProps, withRouter} from "react-router";
import {parseId} from "../../../helpers/convertersAndTransformers";
import {loadDoExerciseSite} from "../../../state/actions/assessmentStatisticsSite/assessmentStatisticsSiteActions";
import ListView from './listView'
import ChartView from './chartView/chartView'

//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string
}

const mapStateToProps = (rootState: RootState /*, props: MyProps*/) => {
  return {
    //test0: rootState...
    //test: props.test
    currentUserId: rootState.userDataSettingsSate.userData
      ? rootState.userDataSettingsSate.userData.id
      : -1,

    assessmentStatistics: rootState.assessmentStatisticsSiteState.assessmentStatistics,
  }
}

const mapDispatchToProps = (dispatch: Dispatch<any>) => bindActionCreators({
  //imported reducer funcs here
  loadDoExerciseSite
}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;


interface MatchedProps {
  readonly targetUserId?: string
}

class assessmentStatisticsSite extends React.Component<Props & RouteComponentProps<MatchedProps>, any> {

  async componentWillMount(): Promise<void> {

    // noinspection TsLint
    let targetUserId = parseId(this.props.match.params.targetUserId)

    if (!targetUserId || targetUserId <= 0) {
      // errorDialog(
      //   translate(TranslateIds.error),
      //   translate(TranslateIds.someUrlParametersNotFound)
      // )
      // return

      targetUserId = this.props.currentUserId
    }

    this.props.loadDoExerciseSite(targetUserId)

  }

  render(): JSX.Element {

    // if (!this.props.assessmentStatistics) {
    //   return null
    // }

    return (
      <div className="multiple-single-panels">

        <ChartView/>

        <ListView/>

      </div>
    )
  }
}

export default withRouter(connect(mapStateToProps, mapDispatchToProps)(assessmentStatisticsSite))