/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../../../state/reducers/index";
import {DetailedHTMLProps, HTMLProps} from "react";
import TestSpinner from './testSpinner'

//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string
  readonly number: number
  readonly isValid: boolean | null
  readonly isTestRunning: boolean

  readonly isEnabled: boolean
  /**
   * calls the on click handler if isTestRunning = false
   */
  readonly onClick: () => void
}

const mapStateToProps = (rootState: RootState, props: MyProps & HTMLProps<HTMLDivElement>) => {
  return {
    //test0: rootState...
    //test: props.test
    ...props,
  }
}

const mapDispatchToProps = (dispatch: Dispatch<any>) => bindActionCreators({
  //imported reducer funcs here

}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

class testNumber extends React.Component<Props, any> {

  render(): JSX.Element {

    const validCssClass = this.props.isValid === null
      ? ''
      : (this.props.isValid === true ? 'valid' : 'invalid')

    return (
      <div className={`flexed ${this.props.isEnabled ? '' : 'div-disabled'}`}>
        <div
          className={` ${this.props.isTestRunning ? 'test-number-disabled' : 'test-number'} ${validCssClass} ${this.props.className ? this.props.className : ''}`}
          onClick={() => {

            if (this.props.isTestRunning) return

            this.props.onClick()
          }}
        >
          {
            this.props.isTestRunning &&
            <TestSpinner/>
          }

          {
            this.props.number
          }
        </div>
      </div>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(testNumber)