/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../../../state/reducers/index";
import {Icon, Popup} from "semantic-ui-react";
import {openCreateCodeTemplateDialog} from "../../../../state/actions/exerciseEditorSite/dialogs/changeCodeTemplateDialog/changeCodeTemplateDialogActions";
import {HelpPopup} from "../../../helpers/helpPopup";
import {translate} from "../../../../../i18n/translationHelper";
import {TranslateIds} from "../../../../../i18n/ids";

//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string
}

const mapStateToProps = (rootState: RootState /*, props: MyProps*/) => {
  return {
    //test0: rootState...
    //test: props.test
    allPLangs: rootState.pLangsState.pLangs,
    allCodeTemplates: rootState.exerciseEditorState.editorExercise.codeTemplates,
  }
}

const mapDispatchToProps = (dispatch: Dispatch<any>) => bindActionCreators({
  //imported reducer funcs here
  openCreateCodeTemplateDialog
}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

class TemplatesPanelHeaderBar extends React.Component<Props, any> {
  render(): JSX.Element {

    const possiblePLangs = this.props.allPLangs.filter(pLang => {
      const codeTemplatePLang = this.props.allCodeTemplates.find(codeTemplate => codeTemplate.pLangId === pLang.id)
      return !codeTemplatePLang
    })

    return (
      <div className="flexed">

        <div className={`clickable mar-right-half ${possiblePLangs.length === 0 ? 'div-disabled' : ''}`}
             onClick={() => {
               this.props.openCreateCodeTemplateDialog()
             }}
        >
          <Icon name="add"/>
          <span>
            {
              translate(TranslateIds.add)
            }
          </span>
        </div>
        {
          (possiblePLangs.length === 0) &&
          <HelpPopup defaultText={translate(TranslateIds.allPLangsAlreadyHaveATemplate)}/>
        }

      </div>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(TemplatesPanelHeaderBar)