/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../../../state/reducers/index";
import {setDescriptionContent} from "../../../../state/actions/exerciseEditorSite/subSets/editorExerciseDescriptionActions";
import SimpleCodeEditorWrapper from '../../../codeEditors/simpleCodeEditorWrapper'
import {aceTextLanguage} from "../../../../helpers/editorHelper";
import {EditorTab} from "../../../codeEditors/multiTabCodeEditorProps";

//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string

  readonly descriptionContent: string

  readonly setContent: (content: string) => void

}

const mapStateToProps = (rootState: RootState , props: MyProps) => {
  return {
    //test0: rootState...
    //test: props.test
    descriptionContent: props.descriptionContent,
    setContent: props.setContent,
  }
}

const mapDispatchToProps = (dispatch: Dispatch<any>) => bindActionCreators({
  //imported reducer funcs here
}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;


//autocomplete
//https://github.com/Microsoft/monaco-editor/issues/74
//https://github.com/Microsoft/monaco-editor/issues/495

class DescriptionEditorPanelView extends React.Component<Props, any> {
  render(): JSX.Element {

    const tempEditorTab: EditorTab = {
      id: 0,
      content: this.props.descriptionContent,
      language: 'markdown',
      editSession: null,
      isReadonly: false,
      fileNameWithExtensions: '',
      displayIndex: 1,
      isMainFile: true,
    }

    return (
      <div id="exerciseEditorEditor"
        className="fh" style={{overflow: 'hidden'}}>

        <SimpleCodeEditorWrapper
          id="exerciseEditorPanelView"
          resizeAnchorId="exerciseEditorEditor"
          editorTab={tempEditorTab}
          onChange={(editorTab) => {
            this.props.setContent(editorTab.content)
          }}
          onEditorSessionChanged={null}
        />

      </div>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(DescriptionEditorPanelView)