/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../../../state/reducers/index";
import {InputOnChangeEvent, TextAreaOnChangeEvent} from "../../../../types/reactEvents";
import {setNote} from "../../../../state/actions/exerciseEditorSite/exerciseEditorActions";
import MaterialTextArea from '../../../material/materialTextArea'

//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string
}

const mapStateToProps = (rootState: RootState /*, props: MyProps*/) => {
  return {
    //test0: rootState...
    //test: props.test
    note: rootState.exerciseEditorState.editorExercise.note
  }
}

const mapDispatchToProps = (dispatch: Dispatch<any>) => bindActionCreators({
  //imported reducer funcs here
  setNote
}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

class notePanelView extends React.Component<Props, any> {
  render(): JSX.Element {
    return (
      <div className="mar-right fh">

        <MaterialTextArea
          className="full-w fh"
          value={this.props.note ? this.props.note : ''}
          onChange={(e: TextAreaOnChangeEvent) => {
            this.props.setNote(e.currentTarget.value)
          }}
        />
        {
          /*

        <textarea
          className="full-w" style={{height: '100px'}}
          value={this.props.note ? this.props.note : ''}
          onChange={(e: TextAreaOnChangeEvent) => {
            this.props.setNote(e.currentTarget.value)
          }}
        ></textarea>
        */
        }

      </div>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(notePanelView)