/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../../../state/reducers/index";
import {Divider} from "semantic-ui-react";
import SaveButton from "../../../buttons/saveButton";
import CancelButton from "../../../buttons/cancelButton";
import ChangeGroupRoleView from './changeGroupRoleView'
import {
  cancelEditGroupRole,
  setIsChangeDialogDisplayed
} from "../../../../state/actions/groupRolesSite/groupRolesSiteActions";
import Spinner from "../../../helpers/Spinner";
import {
  createGroupRolesAsync,
  updateGroupRolesAsync
} from "../../../../state/actions/groupRolesSite/dialog/groupRoleDialogCrudActions";
import {translate} from "../../../../../i18n/translationHelper";
import {TranslateIds} from "../../../../../i18n/ids";

//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string
}

const mapStateToProps = (rootState: RootState /*, props: MyProps*/) => {
  return {
    //test0: rootState...
    //test: props.test
    dialogState: rootState.groupRolesChangeDialogState,
  }
}

const mapDispatchToProps = (dispatch: Dispatch<any>) => bindActionCreators({
  //imported reducer funcs here
  createGroupRolesAsync,
  updateGroupRolesAsync,
  cancelEditGroupRole

}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

class changeGroupRoleDialog extends React.Component<Props, any> {
  render(): JSX.Element {
    return (
      <div>

        {
          this.props.dialogState.isBusy &&
          <Spinner/>
        }

        <div className="view-padding">
          <div>
            <div className="view-caption">
              <h2>
                {
                  this.props.dialogState.isCreating &&
                  translate(TranslateIds.createGroupRole)
                }
                {
                  !this.props.dialogState.isCreating &&
                  translate(TranslateIds.changeGroupRole)
                }
              </h2>
            </div>
          </div>

          <div className="view-content">
            <ChangeGroupRoleView/>

            <Divider/>

            <div className="flexed">
              <SaveButton className="mar-right" disabled={!this.props.dialogState.isValid}
                          onClick={() => {

                            if (this.props.dialogState.isCreating) {
                              this.props.createGroupRolesAsync(this.props.dialogState.groupRole)
                            } else {
                              this.props.updateGroupRolesAsync(this.props.dialogState.groupRole)
                            }
                            //setIsChangeDialogDisplayed and reset gets called in reducer
                          }}
              />
              <CancelButton onClick={() => {
                this.props.cancelEditGroupRole()
              }}/>
            </div>

          </div>
        </div>
      </div>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(changeGroupRoleDialog)