/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../../state/reducers/index";
import SinglePanelSiteWrapper from '../../singlePanelSiteWrapper'
import GroupRolesCardsView from './groupRolesCardsView'
import MaterialSearchInput from '../../material/materialSearchInput'
import Spinner from "../../helpers/Spinner";
import ChangeGroupRoleDialog from './dialogs/changeGroupRoleDialog'
import {getGroupRolesAsync} from "../../../state/actions/groupRolesSite/groupRolesCrudActions";
import {loadGroupRolesSite} from "../../../state/actions/groupRolesSite/groupRolesSiteActions";
import {translate} from "../../../../i18n/translationHelper";
import {TranslateIds} from "../../../../i18n/ids";

//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string
}

const mapStateToProps = (rootState: RootState /*, props: MyProps*/) => {
  return {
    //test0: rootState...
    //test: props.test
    isChangeDialogDisplayed: rootState.groupRolesState.isChangeDialogDisplayed,
    isLoading: rootState.groupRolesState.isLoading
  }
}

const mapDispatchToProps = (dispatch: Dispatch<any>) => bindActionCreators({
  //imported reducer funcs here
  loadGroupRolesSite
}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

class GroupRolesSite extends React.Component<Props, any> {

  constructor() {
    super()
  }

  componentWillMount(): void {
    this.props.loadGroupRolesSite()
  }

  render(): JSX.Element {
    return (
      <SinglePanelSiteWrapper>

        {
          this.props.isLoading &&
          <Spinner/>
        }

        {
          !this.props.isChangeDialogDisplayed &&
          <div className="view-padding">
            <div className="view-head-line">
              <div className="view-caption">
                <h1>
                  {
                    translate(TranslateIds.groupRoles)
                  }
                </h1>
              </div>
              <div className="view-options">
                <MaterialSearchInput/>
              </div>
            </div>

            <div className="view-content">
              <GroupRolesCardsView/>
            </div>
          </div>
        }

        {
          !this.props.isLoading && this.props.isChangeDialogDisplayed &&
          <ChangeGroupRoleDialog/>
        }

      </SinglePanelSiteWrapper>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(GroupRolesSite)