/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../../state/reducers/index";
import CommonHeaderBarContentWrapper from '../../commonHeaderBarContentWrapper'
import {Icon} from "semantic-ui-react";
import ViewStateChanger from '../../helpers/viewStateChanger'
import {openCreateGroupDialog, setViewState} from "../../../state/actions/groupsSite/groupsSiteActions";
import {translate} from "../../../../i18n/translationHelper";
import {TranslateIds} from "../../../../i18n/ids";

//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string
}

const mapStateToProps = (rootState: RootState /*, props: MyProps*/) => {
  return {
    //test0: rootState...
    //test: props.test
    viewState: rootState.groupsState.viewState,
    isLoading: rootState.groupsState.isLoading,
    isChangeDialogDisplayed: rootState.groupsState.isChangeDialogDisplayed,

    systemRole: rootState.userDataSettingsSate.userData
    && rootState.userDataSettingsSate.userData.systemRole
      ? rootState.userDataSettingsSate.userData.systemRole
      : null,
  }
}

const mapDispatchToProps = (dispatch: Dispatch<any>) => bindActionCreators({
  //imported reducer funcs here
  setViewState,
  openCreateGroupDialog
}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

class headerBarContent extends React.Component<Props, any> {
  render(): JSX.Element {

    const leftArea = (
      <div>
        {
          (this.props.systemRole && this.props.systemRole.canCreateGroups) &&
          <div className="clickable"
               onClick={() => {
                 this.props.openCreateGroupDialog()
               }}
          >
            <Icon name="plus"/>
            <span>
            {
              translate(TranslateIds.createGroup)
            }
          </span>
          </div>
        }

      </div>
    )
    const rightArea = (
      <ViewStateChanger viewState={this.props.viewState}
                        setViewStateFunc={(viewState) => this.props.setViewState(viewState)}/>
    )

    return (
      <CommonHeaderBarContentWrapper leftArea={leftArea} rightArea={rightArea} disabled={this.props.isLoading}/>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(headerBarContent)