/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../../state/reducers/index";
import {Icon} from "semantic-ui-react";
import CommonHeaderBarContentWrapper from '../../commonHeaderBarContentWrapper'
import {deleteMultipleActivatedUserAsync} from "../../../state/actions/manageActivatedUsersSite/manageActivatedUsersSiteCrudActions";
import {translate} from "../../../../i18n/translationHelper";
import {TranslateIds} from "../../../../i18n/ids";


//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string
}

const mapStateToProps = (rootState: RootState /*, props: MyProps*/) => {
  return {
    //test0: rootState...
    //test: props.test
    isLoading: rootState.manageActivatedUsersState.isLoading,
    activatedUsers: rootState.manageActivatedUsersState.activatedUsers,

    systemRole: rootState.userDataSettingsSate.userData
    && rootState.userDataSettingsSate.userData.systemRole
      ? rootState.userDataSettingsSate.userData.systemRole
      : null,
  }
}

const mapDispatchToProps = (dispatch: Dispatch<any>) => bindActionCreators({
  //imported reducer funcs here
  deleteMultipleActivatedUserAsync
}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

class headerBar extends React.Component<Props, any> {


  render(): JSX.Element {

    const isSomeUserSelected = this.props.activatedUsers.some(p => p.uiIsSelected)

    const leftArea = (
      <div>
        {
          (this.props.systemRole && this.props.systemRole.canDeleteActivatedUsers) &&
          <div className={isSomeUserSelected ? 'clickable' : 'div-disabled'}
               onClick={() => {
                 this.props.deleteMultipleActivatedUserAsync(
                   this.props.activatedUsers.filter(p => p.uiIsSelected)
                 )
               }}
          >
            <Icon name="remove"/>
            <span>
            {
              translate(TranslateIds.deleteSelectedUsers)
            }
          </span>
          </div>
        }


      </div>
    )


    return (
      <CommonHeaderBarContentWrapper leftArea={leftArea} disabled={this.props.isLoading}/>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(headerBar)