/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../../state/reducers/index";
import SinglePanelSiteWrapper from '../../singlePanelSiteWrapper'
import {Input, Icon} from "semantic-ui-react";
import ActivatedUsersListView from './activatedUsersListView'
import {Route, RouteComponentProps, withRouter} from 'react-router'
import MaterialSearchInput from '../../material/materialSearchInput'
import Spinner from "../../helpers/Spinner";
import ChangeUserDataDialog from './dialogs/changeUserDataDialog'
import {loadManageActivatedUsersSite} from "../../../state/actions/manageActivatedUsersSite/manageActivatedUsersSiteActions";
import {translate} from "../../../../i18n/translationHelper";
import {TranslateIds} from "../../../../i18n/ids";

//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string
}

const mapStateToProps = (rootState: RootState /*, props: MyProps*/) => {
  return {
    //test0: rootState...
    //test: props.test
    isLoading: rootState.manageActivatedUsersState.isLoading,
    isChangeUserDataDialogDisplayed: rootState.manageActivatedUsersState.isChangeUserDataDialogDisplayed,
  }
}

const mapDispatchToProps = (dispatch: Dispatch<any>) => bindActionCreators({
  //imported reducer funcs here
  loadManageActivatedUsersSite
}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

class ManageUsersSite extends React.Component<Props & RouteComponentProps<any>, any> {

  componentWillMount(): void {
    this.props.loadManageActivatedUsersSite()
  }

  render(): JSX.Element {

    return (
      <SinglePanelSiteWrapper>

        {
          this.props.isLoading &&
          <Spinner/>
        }

        {
          !this.props.isChangeUserDataDialogDisplayed &&
          <div className="view-padding">
            <div className="view-head-line">
              <div className="view-caption">
                <h1>
                  {
                    translate(TranslateIds.manageActivatedUsers)
                  }
                </h1>
              </div>
              <div className="view-options">
                <MaterialSearchInput/>
              </div>
            </div>

            <div className="view-content">
              <ActivatedUsersListView/>
            </div>
          </div>
        }

        {
          !this.props.isLoading && this.props.isChangeUserDataDialogDisplayed &&
          <ChangeUserDataDialog/>
        }

      </SinglePanelSiteWrapper>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(ManageUsersSite)