/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../../state/reducers/index";
import {Icon} from "semantic-ui-react";
import {SimpleVDivider} from "../../helpers/simpleVDivider";
import CommonHeaderBarContentWrapper from '../../commonHeaderBarContentWrapper'
import {Link} from "react-router-dom";
import * as constants from '../../../constants'
import {deleteMultipleActivatedUserAsync} from "../../../state/actions/manageActivatedUsersSite/manageActivatedUsersSiteCrudActions";
import {translate} from "../../../../i18n/translationHelper";
import {TranslateIds} from "../../../../i18n/ids";

//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string
}

const mapStateToProps = (rootState: RootState /*, props: MyProps*/) => {
  return {
    //test0: rootState...
    //test: props.test
    isLoading: rootState.manageCustomProjectsSiteState.isLoading
    || rootState.systemSettingsState.isLoading
    ,
    systemSettings: rootState.systemSettingsState.systemSettings,
    customProjectPreviews: rootState.manageCustomProjectsSiteState.customProjectPreviews

  }
}

const mapDispatchToProps = (dispatch: Dispatch<any>) => bindActionCreators({
  //imported reducer funcs here
  deleteMultipleActivatedUserAsync
}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

class headerBar extends React.Component<Props, any> {


  render(): JSX.Element {

    console.log(this.props.systemSettings)

    const leftArea = (
      <div className="flexed">

        {
          this.props.customProjectPreviews.length < this.props.systemSettings.maxCustomProjectsPerUser &&
          <div>
            <Link to={constants.createCustomProjectSiteToLinkPath}>
              <Icon name="add"/>
              <span>
            {
              translate(TranslateIds.createCustomProject)
            }
          </span>
            </Link>
          </div>
        }
        {
          this.props.customProjectPreviews.length < this.props.systemSettings.maxCustomProjectsPerUser &&
          <SimpleVDivider/>
        }

        <div>
          {
            `${this.props.systemSettings.maxCustomProjectsPerUser - this.props.customProjectPreviews.length} ${translate(
              TranslateIds.numCustomProjectsLeft)}`
          }
        </div>

      </div>
    )


    return (
      <CommonHeaderBarContentWrapper leftArea={leftArea} disabled={this.props.isLoading}/>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(headerBar)