/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {cancelEditExerciseRelease} from "../../../../../../state/actions/ownOrGroupExerciseActions/releasesSiteActions/dialogs/changeExerciseReleaseDialog/changeExerciseReleaseDialogActions";
import {RootState} from "../../../../../../state/reducers/index";
import Spinner from "../../../../../helpers/Spinner";
import {Divider} from "semantic-ui-react";
import SaveButton from "../../../../../buttons/saveButton";
import CancelButton from "../../../../../buttons/cancelButton";
import ChangeReleaseView from './changeReleaseView'
import {
  createExerciseReleaseAsync,
  updateExerciseReleaseAsync
} from "../../../../../../state/actions/ownOrGroupExerciseActions/releasesSiteActions/dialogs/changeExerciseReleaseDialog/changeExerciseReleaseDialogCrudActions";
import {translate} from "../../../../../../../i18n/translationHelper";
import {TranslateIds} from "../../../../../../../i18n/ids";

//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string
}

const mapStateToProps = (rootState: RootState /*, props: MyProps*/) => {
  return {
    //test0: rootState...
    //test: props.test
    dialogState: rootState.changeExerciseReleaseDialogState,
    selectedExerciseId: rootState.releaseSiteState.selectedExerciseId
  }
}

const mapDispatchToProps = (dispatch: Dispatch<any>) => bindActionCreators({
  //imported reducer funcs here
  cancelEditExerciseRelease,
  createExerciseReleaseAsync,
  updateExerciseReleaseAsync
}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

class changeSystemRoleDialog extends React.Component<Props, any> {
  render(): JSX.Element {
    return (
      <div>
        {
          this.props.dialogState.isBusy &&
          <Spinner/>
        }

        <div className="view-padding">
          <div>
            <div className="view-caption">
              <h2>
                {
                  this.props.dialogState.isCreatingExerciseRelease &&
                  translate(TranslateIds.createRelease)
                }
                {
                  !this.props.dialogState.isCreatingExerciseRelease &&
                  translate(TranslateIds.changeRelease)
                }
              </h2>
            </div>
          </div>

          <div className="view-content">
            <ChangeReleaseView/>

            <Divider/>

            <div className="flexed">
              <SaveButton className="mar-right" disabled={!this.props.dialogState.isValid}
                          onClick={() => {

                            if (this.props.dialogState.isCreatingExerciseRelease) {
                              this.props.createExerciseReleaseAsync(this.props.selectedExerciseId,
                                this.props.dialogState.exerciseRelease)
                            } else {
                              this.props.updateExerciseReleaseAsync(this.props.selectedExerciseId,
                                this.props.dialogState.exerciseRelease)
                            }
                          }}
              />
              <CancelButton onClick={() => {
                this.props.cancelEditExerciseRelease()
              }}/>
            </div>

          </div>
        </div>
      </div>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(changeSystemRoleDialog)