/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../../../state/reducers/index";
import {Icon} from "semantic-ui-react";
import CommonHeaderBarContentWrapper from '../../../commonHeaderBarContentWrapper'
import {
  openCreateExerciseRelease,
  resetChangeExerciseReleaseDialog,
  setIsCreatingExerciseRelease
} from "../../../../state/actions/ownOrGroupExerciseActions/releasesSiteActions/dialogs/changeExerciseReleaseDialog/changeExerciseReleaseDialogActions";
import {setIsChangeDialogDisplayedAction} from "../../../../state/actions/ownOrGroupExerciseActions/releasesSiteActions/exerciseReleasesSiteActions";
import {translate} from "../../../../../i18n/translationHelper";
import {TranslateIds} from "../../../../../i18n/ids";


//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string
}

const mapStateToProps = (rootState: RootState /*, props: MyProps*/) => {
  return {
    //test0: rootState...
    //test: props.test
    isLoading: rootState.releaseSiteState.isLoading
    || rootState.groupStorageState.isLoading
    ,

    groupRole: rootState.groupStorageState.userGroupRole ? rootState.groupStorageState.userGroupRole : null
  }
}

const mapDispatchToProps = (dispatch: Dispatch<any>) => bindActionCreators({
  //imported reducer funcs here
  openCreateExerciseRelease
}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

class HeaderBar extends React.Component<Props, any> {
  render(): JSX.Element {

    const leftArea = (
      <div>

        {
          (this.props.groupRole && this.props.groupRole.canReleaseExercises) &&
          <div className="clickable"
               onClick={() => {
                 this.props.openCreateExerciseRelease()
               }}
          >
            <Icon name="plus"/>
            <span>
            {
              translate(TranslateIds.createRelease)
            }
          </span>
          </div>
        }


      </div>
    )


    return (
      <CommonHeaderBarContentWrapper leftArea={leftArea} disabled={this.props.isLoading}/>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(HeaderBar)