/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../../../../state/reducers/index";
import {AddableUserFrontendExclusive} from "../../../../../types/users";
import {Checkbox, Table, Icon} from "semantic-ui-react";
import {CheckboxOnChangeEventData} from "../../../../../types/reactEvents";

//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string
  readonly user: AddableUserFrontendExclusive

  readonly setUserSelected: (user: AddableUserFrontendExclusive, isSelected: boolean) => void
}

const mapStateToProps = (rootState: RootState, props: MyProps) => {
  return {
    //test0: rootState...
    //test: props.test
    user: props.user,
    setUserSelected: props.setUserSelected
  }
}

const mapDispatchToProps = (dispatch: Dispatch<any>) => bindActionCreators({
  //imported reducer funcs here

}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

class listViewItem extends React.Component<Props, any> {

  render(): JSX.Element {

    const user = this.props.user

    return (
      <Table.Row>
        <Table.Cell>
          <div>
            <Checkbox checked={user.uiIsSelected}
                      onChange={(e, data: CheckboxOnChangeEventData) => {
                        this.props.setUserSelected(user, data.checked)
                      }}
            />
          </div>
        </Table.Cell>

        <Table.Cell>
          <span>{user.lastName}</span>
        </Table.Cell>

        <Table.Cell>
          <span>{user.firstName}</span>
        </Table.Cell>

        <Table.Cell>
          <span>{user.token}</span>
        </Table.Cell>

        <Table.Cell>
          {
            //TODO icon or checkbox??
            //checkbox is more precises than different icons??
            //<Icon name={member.isActivated ? 'user' : 'user outline'} />
          }
          {
            <Checkbox checked={user.isActive} disabled/>
          }
        </Table.Cell>

        <Table.Cell>
          <Icon name="clone" className="clickable"/>
          <span>{user.email}</span>
        </Table.Cell>
      </Table.Row>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(listViewItem)