/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../../../state/reducers/index";
import ChangeSystemRoleView from './changeSystemRoleView'
import {Button, Divider} from "semantic-ui-react";
import SaveButton from "../../../buttons/saveButton";
import CancelButton from "../../../buttons/cancelButton";
import {
  cancelEditSystemRole,
  setIsChangeDialogDisplayed
} from "../../../../state/actions/systemRolesSite/systemRolesSiteActions";
import {SystemRoleFullBase} from "../../../../types/userData";
import Spinner from "../../../helpers/Spinner";
import {
  createSystemRoleAsync,
  updateSystemRoleAsync
} from "../../../../state/actions/systemRolesSite/dialog/systemRolesDialogCrudActions";
import {translate} from "../../../../../i18n/translationHelper";
import {TranslateIds} from "../../../../../i18n/ids";

//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string
}

const mapStateToProps = (rootState: RootState /*, props: MyProps*/) => {
  return {
    //test0: rootState...
    //test: props.test
    dialogState: rootState.systemRolesChangeDialogState,
  }
}

const mapDispatchToProps = (dispatch: Dispatch<any>) => bindActionCreators({
  //imported reducer funcs here
  createSystemRoleAsync,
  updateSystemRoleAsync,
  cancelEditSystemRole

}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

class changeSystemRoleDialog extends React.Component<Props, any> {
  render(): JSX.Element {
    return (
      <div>
        {
          this.props.dialogState.isBusy &&
          <Spinner/>
        }

        <div className="view-padding">
          <div>
            <div className="view-caption">
              <h2>
                {
                  this.props.dialogState.isCreating &&
                  translate(TranslateIds.createSystemRole)
                }
                {
                  !this.props.dialogState.isCreating &&
                  translate(TranslateIds.changeSystemRole)
                }
              </h2>
            </div>
          </div>

          <div className="view-content">
            <ChangeSystemRoleView/>

            <Divider/>

            <div className="flexed">
              <SaveButton className="mar-right" disabled={!this.props.dialogState.isValid}
                          onClick={() => {

                            if (this.props.dialogState.isCreating) {
                              this.props.createSystemRoleAsync(this.props.dialogState.systemRole)
                            } else {
                              this.props.updateSystemRoleAsync(this.props.dialogState.systemRole)
                            }
                          }}
              />
              <CancelButton onClick={() => {
                this.props.cancelEditSystemRole()
              }}/>
            </div>

          </div>
        </div>
      </div>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(changeSystemRoleDialog)