/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../../../state/reducers/index";
import {Icon} from "semantic-ui-react";
import CommonHeaderBarContentWrapper from '../../../commonHeaderBarContentWrapper'
import {changeSingleAssessmentTutorViewAsync} from "../../../../state/actions/tutorViewSite/tutorViewSiteCrudActions";
import {translate} from "../../../../../i18n/translationHelper";
import {TranslateIds} from "../../../../../i18n/ids";

//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string
}

const mapStateToProps = (rootState: RootState /*, props: MyProps*/) => {
  return {
    //test0: rootState...
    //test: props.test
    isLoading: rootState.tutorViewSiteState.isLoading,
    assessment: rootState.tutorViewSiteState.assessment,
  }
}

const mapDispatchToProps = (dispatch: Dispatch<any>) => bindActionCreators({
  //imported reducer funcs here
  changeSingleAssessmentTutorViewAsync,
}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

class HeaderBar extends React.Component<Props, any> {
  render(): JSX.Element {

    const leftArea = (
      <div>
        <div className="clickable"
             onClick={() => {
               this.props.changeSingleAssessmentTutorViewAsync(this.props.assessment)
             }}
        >
          <Icon name="checkmark"/>
          <span>
            {
              translate(TranslateIds.saveManualAssessment)
            }
          </span>
        </div>

      </div>
    )


    return (
      <div className={'flexed full-w' + (this.props.isLoading ? ' div-disabled' : '')}>
        <div className="flexed full-w">
          <div>
            {leftArea}
          </div>

        </div>
      </div>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(HeaderBar)