import {AwaitActions} from "../types";
import {
  getClientServerSettingsAsync, getHardwareUsageAsync, getLogicalUsageAsync,
  getTestServerSettingsAsync
} from "./dashboardCrudActions";
import {ResetAction, SET_isLoadingAction} from "../../reducers/dashboardSite/dashboardSiteReducer";
import {ActionType} from "../../reducers/dashboardSite/dashboardSiteActionTypes";

/**
 * Created by janis dähne.
 */


export function loadDashboardSite(): AwaitActions {
  return async (dispatch, getState) => {

    dispatch(resetDashboardSite())


    try {
      await dispatch(getLogicalUsageAsync())
    } catch(err) {
        
    }

    try {
      await dispatch(getClientServerSettingsAsync())
    } catch(err) {
        
    }

    try {
      await dispatch(getTestServerSettingsAsync())
    } catch(err) {

    }

    dispatch(setIsLoadingDashboardSite(true))

    try {
      await dispatch(getHardwareUsageAsync())
    } catch(err) {

    }
    finally {
      dispatch(setIsLoadingDashboardSite(false))
    }



  }
}

export function setIsLoadingDashboardSite(isLoading: boolean): SET_isLoadingAction {
  return {
    type: ActionType.SET_isLoading,
    isLoading
  }
}


export function resetDashboardSite(): ResetAction {
  return {
    type: ActionType.RESET
  }
}