/**
 * Created by janis dähne.
 */
import {CustomProjectTestFullBase} from "../../../../../types/customProjects";
import {
  createCustomProjectTest,
  updateCustomProjectTest
} from "../../../../../communicationLayer/editCustomProjectLayer";
import {delay} from "../../../../../../debug";
import {CREATE_customProjectTestAction} from "../../../../reducers/editCustomProjectSite/dialogs/changeCustomProjectTestDialog/createCustomProjectTestReducer";
import {ActionType} from "../../../../reducers/editCustomProjectSite/dialogs/changeCustomProjectTestDialog/changeCustomProjectTestDialogActionTypes";
import {UPDATE_customProjectReducerAction} from "../../../../reducers/editCustomProjectSite/dialogs/changeCustomProjectTestDialog/updateCustomProjectTestReducer";


export function createProjectTest(customProjectId: number, customTest: CustomProjectTestFullBase): CREATE_customProjectTestAction {
  return {
    type: ActionType.CREATE_customProjectTest,
    payload: delay(createCustomProjectTest(customProjectId, customTest))
  }
}

export function updateProjectTest(customProjectId: number, customTest: CustomProjectTestFullBase): UPDATE_customProjectReducerAction {
  return {
    type: ActionType.UPDATE_customProjectReducer,
    payload: delay(updateCustomProjectTest(customProjectId, customTest))
  }
}