/**
 * Created by janis dähne.
 */

import {ActionType} from "../../../../reducers/exerciseEditorSite/dialogs/changeCodeTemplateDialog/changeCodeTemplateDialogActionTypes";
import {ExerciseCodeTemplateFileFullBase, ExerciseCodeTemplateFullBase} from "../../../../../types/exerciseEditor";
import {
  SET_mainFileIdAction,
  SET_pLangIdAction, SET_templateFilesAction
} from "../../../../reducers/exerciseEditorSite/dialogs/changeCodeTemplateDialog/codeTemplateReducer";
import {
  SET_codeTemplateAction,
  SET_selectedEditorTabIdAction
} from "../../../../reducers/exerciseEditorSite/dialogs/changeCodeTemplateDialog/changeCodeTemplateDialogReducer";
import {AwaitActions, MultiActions} from "../../../types";
import {openTabChangeCodeTemplate} from "./changeCodeTemplateDialogActions";
import {setSolutionFiles_AndRefreshEditor} from "../../../../../helpers/editorHelper";
import {setForceEditorUpdateSessionDummyCreateExerciseTemplateEditor} from "../../../editorHelperState/editorHelperStateActions";


export function setChangCodeTemplate(codeTemplate: ExerciseCodeTemplateFullBase): SET_codeTemplateAction {
  return {
    type: ActionType.SET_codeTemplate,
    codeTemplate
  }
}

export function setPLangId(pLangId: number): SET_pLangIdAction {
  return {
    type: ActionType.SET_pLangId,
    pLangId
  }
}

export function setMainFileId(mainFileId: number): SET_mainFileIdAction {
  return {
    type: ActionType.SET_mainFileId,
    mainFileId
  }
}

export function onCreateTemplateFile(newFile: ExerciseCodeTemplateFileFullBase, templateFiles: ReadonlyArray<ExerciseCodeTemplateFileFullBase>, selectedEditorTabId: number): AwaitActions {
  return async (dispatch) => {

    const newTemplateFiles: ReadonlyArray<ExerciseCodeTemplateFileFullBase> = [...templateFiles, newFile]

    await dispatch(setSolutionFiles_AndRefreshEditor(
      newTemplateFiles,
      setTemplateFiles,
      setForceEditorUpdateSessionDummyCreateExerciseTemplateEditor
      )
    )

    if (templateFiles.length === 0) {
      //this is the first file set it as the main file
      dispatch(setMainFileId(newFile.id))
    }

    // this.props.setTemplateFiles(
    //   newTemplateFiles
    // )

    //open the new file
    dispatch(openTabChangeCodeTemplate(newFile, newTemplateFiles, selectedEditorTabId))

  }
}

export function setTemplateFiles(templateFiles: ReadonlyArray<ExerciseCodeTemplateFileFullBase>): SET_templateFilesAction {
  return {
    type: ActionType.SET_templateFiles,
    templateFiles
  }
}


export function setSelectedEditorTabIdChangeCodeTemplate(selectedEditorTabId: number): SET_selectedEditorTabIdAction {
  return {
    type: ActionType.SET_selectedEditorTabId,
    selectedEditorTabId
  }
}
