/**
 * Created by janis dähne.
 */
import {
  ResetAction,
  SET_selectedTagIdsAction
} from "../../../../reducers/exerciseEditorSite/dialogs/changeSelectedTagsDialog/changeSelectedTagsDialogReducer";
import {ActionType} from "../../../../reducers/exerciseEditorSite/dialogs/changeSelectedTagsDialog/changeSelectedTagsDialogReducer";
import {MultiActions} from "../../../types";
import {setIsChangeSelectedTagsDialogDisplayed} from "../../exerciseEditorSiteActions";
import {setTagIds} from "../../subSets/editorExerciseMetaDataActions";


export function setSelectedTagIds(selectedTagIds: ReadonlyArray<number>): SET_selectedTagIdsAction {
  return {
    type: ActionType.SET_selectedTagIds,
    selectedTagIds
  }
}




export function openEditChangeSelectedTagDialog(selectedTagIds: ReadonlyArray<number>): MultiActions {
  return dispatch => {

    dispatch(resetChangeSelectedTagIds())
    dispatch(setSelectedTagIds(selectedTagIds))

    dispatch(setIsChangeSelectedTagsDialogDisplayed(true))
  }
}

export function applyChangeSelectedTagDialog(selectedTagIds: ReadonlyArray<number>): MultiActions {
  return dispatch => {

    dispatch(setTagIds(selectedTagIds))
    dispatch(resetChangeSelectedTagIds())

    dispatch(setIsChangeSelectedTagsDialogDisplayed(false))
  }
}

export function cancelChangeSelectedTagDialog(): MultiActions {
  return dispatch => {

    dispatch(resetChangeSelectedTagIds())
    dispatch(setIsChangeSelectedTagsDialogDisplayed(false))
  }
}


export function resetChangeSelectedTagIds(): ResetAction {
  return {
    type: ActionType.RESET,
  }
}
