/**
 * Created by janis dähne.
 */

import {ActionType} from "../../../reducers/exerciseEditorSite/editorExerciseSiteActionTypes";
import {ExerciseTestForBackend} from "../../../../types/exerciseEditor";
import {SET_testAction} from "../../../reducers/exerciseEditorSite/subSets/setEditorExerciseTestsReducer";
import {MultiActions} from "../../types";
import orderBy from 'lodash-es/orderBy'

//---ReadonlyArray<ExerciseTestForBackend>

/**
 * sets the tests for the exercise editor
 *
 * corrects sorts the test by display index
 *
 * displayIndices with < 0 are set to the last index
 * @param {ReadonlyArray<ExerciseTestForBackend>} tests
 * @returns {MultiActions}
 */
export function setEditorTests(tests: ReadonlyArray<ExerciseTestForBackend>): MultiActions {
  return dispatch => {

    console.log(tests)
    //if we find any test with < 0 index this is probably a new test ... set the display index here

    const sortedTests = orderBy(tests, p => p.displayIndex)

    //e.g. -1, 0, 1, 2, 3
    // --> countRightIndex = 4
    const countRightIndex = sortedTests.filter(p => p.displayIndex >= 0).length

    // noinspection TsLint
    let count = 0
    // noinspection TsLint
    let normalCount = 0;

    const copy = sortedTests.map(test => {

      return test.displayIndex < 0
        ? {
          ...test,
          displayIndex: countRightIndex + count++
        }
        : {
          ...test,
          displayIndex: normalCount++
        }
    })

    console.log(copy)

    //sort again in case we changed any index
    dispatch(_setEditorTests(orderBy(copy, p => p.displayIndex)))
  }
}


export function _setEditorTests(tests: ReadonlyArray<ExerciseTestForBackend>): SET_testAction {
  return {
    type: ActionType.SET_tests,
    tests
  }
}