/**
 * Created by janis dähne.
 */
import {
  SET_canAddUserToGroupAction,
  SET_canAssessExercisesAction,
  SET_canChangeExercisesAction, SET_canChangeOtherMembersRoleAction, SET_canCopyExercisesAction,
  SET_canCreateExercisesAction, SET_canDeleteExercisesAction, SET_canReleaseExercisesAction,
  SET_canRemoveMemberFromGroupAction,
  SET_canSeeExercisesFromOthersInGroupAction, SET_canSeeOtherUsersAction, SET_displayNameAction,
  SET_idAction
} from "../../../reducers/groupRolesSite/dialog/groupRoleReducer";
import {ActionType} from "../../../reducers/groupRolesSite/dialog/groupRolesDialogActionTypes";
import {GroupRoleWithPermissionFullBase} from "../../../../types/groupRoles";
import {ThunkAction} from "redux-thunk";


export function setTargetGroupRole(systemRole: GroupRoleWithPermissionFullBase): ThunkAction<void, void, void> {
  return (dispatch) => {
    dispatch(setId(systemRole.id))
    dispatch(setDisplayName(systemRole.displayName))
    dispatch(setCanCreateExercises(systemRole.canCreateExercises))
    dispatch(setCanChangeExercises(systemRole.canChangeExercises))
    dispatch(setCanDeleteExercises(systemRole.canDeleteExercises))
    dispatch(setCanReleaseExercises(systemRole.canReleaseExercises))
    dispatch(setCanCopyExercises(systemRole.canCopyExercises))
    dispatch(setCanAssessExercises(systemRole.canAssessExercises))
    dispatch(setCanSeeExercisesFromOthersInGroup(systemRole.canSeeExercisesFromOthersInGroup))
    dispatch(setCanAddUserToGroup(systemRole.canAddUserToGroup))
    dispatch(setCanRemoveMemberFromGroup(systemRole.canRemoveMemberFromGroup))
    dispatch(setCanChangeOtherMembersRole(systemRole.canChangeOtherMembersRole))
    dispatch(setCanSeeOtherUsers(systemRole.canSeeOtherUsers))

  }
}

export function setId(id: number): SET_idAction {
  return {
    type: ActionType.SET_id,
    id
  }
}

export function setDisplayName(displayName: string): SET_displayNameAction {
  return {
    type: ActionType.SET_displayName,
    displayName
  }
}

export function setCanCreateExercises(can: boolean): SET_canCreateExercisesAction {
  return {
    type: ActionType.SET_canCreateExercises,
    can
  }
}

export function setCanChangeExercises(can: boolean): SET_canChangeExercisesAction {
  return {
    type: ActionType.SET_canChangeExercises,
    can
  }
}

export function setCanDeleteExercises(can: boolean): SET_canDeleteExercisesAction {
  return {
    type: ActionType.SET_canDeleteExercises,
    can
  }
}

export function setCanReleaseExercises(can: boolean): SET_canReleaseExercisesAction {
  return {
    type: ActionType.SET_canReleaseExercises,
    can
  }
}

export function setCanCopyExercises(can: boolean): SET_canCopyExercisesAction {
  return {
    type: ActionType.SET_canCopyExercises,
    can
  }
}

export function setCanAssessExercises(can: boolean): SET_canAssessExercisesAction {
  return {
    type: ActionType.SET_canAssessExercises,
    can
  }
}

export function setCanSeeExercisesFromOthersInGroup(can: boolean): SET_canSeeExercisesFromOthersInGroupAction {
  return {
    type: ActionType.SET_canSeeExercisesFromOthersInGroup,
    can
  }
}

export function setCanAddUserToGroup(can: boolean): SET_canAddUserToGroupAction {
  return {
    type: ActionType.SET_canAddUserToGroup,
    can
  }
}

export function setCanRemoveMemberFromGroup(can: boolean): SET_canRemoveMemberFromGroupAction {
  return {
    type: ActionType.SET_canRemoveMemberFromGroup,
    can
  }
}

export function setCanChangeOtherMembersRole(can: boolean): SET_canChangeOtherMembersRoleAction {
  return {
    type: ActionType.SET_canChangeOtherMembersRole,
    can
  }
}

export function setCanSeeOtherUsers(can: boolean): SET_canSeeOtherUsersAction {
  return {
    type: ActionType.SET_canSeeOtherUsers,
    can
  }
}