/**
 * Created by janis dähne.
 */
import {AwaitActions} from "../types";
import {ActionType} from "../../reducers/groupRolesSite/groupRolesSiteActionTypes";
import {delay} from "../../../../debug";
import {deleteEntity, getGroupRoles} from "../../../communicationLayer/groupRolesLayer";
import {GroupRoleWithPermissionFullBase} from "../../../types/groupRoles";
import {DELETE_groupRoleAction} from "../../reducers/groupRolesSite/deleteGroupRoleReducer";
import {GET_groupRolesAction} from '../../reducers/groupRolesSite/getGroupRolesReducer'


export function deleteGroupRoleAsync(groupRole: GroupRoleWithPermissionFullBase): AwaitActions {
  return async (dispatch) => {
    await dispatch(_deleteGroupRoleAsync(groupRole))
    dispatch(getGroupRolesAsync())
  }
}

function _deleteGroupRoleAsync(groupRole: GroupRoleWithPermissionFullBase): DELETE_groupRoleAction {
  return {
    type: ActionType.DELETE_groupRole,
    payload: delay(deleteEntity(groupRole))
  }
}

export function getGroupRolesAsync(): GET_groupRolesAction {
  return {
    type: ActionType.GET_groupRoles,
    payload: delay(getGroupRoles())
  }
}