/**
 * Created by janis dähne.
 */
import {GET_groupsAction} from "../../reducers/groupsSite/getGroupsReducer";
import {delay} from "../../../../debug";
import {ActionType} from '../../reducers/groupsSite/groupsSiteActionTypes'
import {deleteUserGroup, getGroups, removeMember} from "../../../communicationLayer/groupsLayer";
import {QUIT_groupAction} from "../../reducers/groupsSite/quitGroupReducer";
import {AwaitActions} from "../types";
import {UserGroupFullBase} from "../../../types/group";
import {DELETE_userGroupAction} from "../../reducers/groupsSite/deleteGroupReducer";
import {loadGroupsSite} from "./groupsSiteActions";

export function quitGroupAsync(group: UserGroupFullBase): AwaitActions {
  return async (dispatch) => {
    await dispatch(_quitGroupAsync(group))
    dispatch(getGroupsAsync())
  }
}

function _quitGroupAsync(group: UserGroupFullBase): QUIT_groupAction {
  return {
    type: ActionType.QUIT_group,
    payload: delay(removeMember({
      groupId: group.id,
      useCurrentUser: true
    }))
  }
}


/**
 * deletes the given user group and reloads the page
 * @param {number} userGroupId
 * @returns {AwaitActions}
 */
export function deleteUserGroupAsync(userGroupId: number): AwaitActions {
  return async(dispatch, getState) => {

    await dispatch(_deleteUserGroupAsync(userGroupId))

    //then reload
    dispatch(loadGroupsSite())
  }
}

export function _deleteUserGroupAsync(userGroupId: number): DELETE_userGroupAction {
  return {
    type: ActionType.DELETE_userGroup,
    payload: delay(deleteUserGroup(userGroupId)),
  }
}

export function getGroupsAsync(): GET_groupsAction {
  return {
    type: ActionType.GET_groups,
    payload: delay(getGroups())
  }
}