/**
 * Created by janis dähne.
 */
import {
  ResetAction
} from "../../../reducers/manageActivatedUsersSite/dialog/changeActivatedUserDataDialogReducer";
import {SelectableUserFrontendExclusive} from "../../../../types/users";
import {ThunkAction} from "redux-thunk";
import {ActionType} from "../../../reducers/manageActivatedUsersSite/dialog/changeActivatedUserDataDialogActionTypes";
import {noneSystemRole} from "../../../../components/sites/manageActivatedUsersSite/dialogs/changeUserDataView";
import {setTargetUserId, setEmail, setLastName, setFirstName, setSystemRole} from "./activatedUserDataSetActions";


export function setTargetUser(user: SelectableUserFrontendExclusive): ThunkAction<void, void, void> {
  return (dispatch) => {


    //reset old data in case we didn't click on cancel but instead
    //e.g. used browser back button
    dispatch(resetChangeActivatedUserDataDialog())

    dispatch(setTargetUserId(user.id))
    dispatch(setEmail(user.email))
    dispatch(setLastName(user.lastName))
    dispatch(setFirstName(user.firstName))

    dispatch(setSystemRole(user.systemRole ? user.systemRole : noneSystemRole))
  }
}



export function resetChangeActivatedUserDataDialog(): ResetAction {
  return {
    type: ActionType.RESET
  }
}