/**
 * Created by janis dähne.
 */


import {SelectableUserFrontendExclusive, UserPreviewFromBackend} from "../../../types/users";
import {
  ResetAction, SET_isChangeUserDataDialogDisplayedAction,
  SET_activatedUser_uiIsSelectedAction,
  SET_all_activatedUsers_uiIsSelectedAction, SET_sortByKeyAction
} from "../../reducers/manageActivatedUsersSite/manageActivatedUsersSiteReducer";
import {AwaitActions} from "../types";
import {getActivatedUsersAsync, getSystemRolesAsync} from "./manageActivatedUsersSiteCrudActions";
import {ActionType} from "../../reducers/manageActivatedUsersSite/manageActivatedUsersSiteActionTypes";
import {SortDirection} from "../../../types/sortDirection";


export function setActivatedUserUiIsSelected(activatedUserId: number, isSelected: boolean): SET_activatedUser_uiIsSelectedAction {
  return {
    type: ActionType.SET_activatedUser_uiIsSelected,
    newUserId: activatedUserId,
    isSelected
  }
}
export function setSortByKey(sortByKey: keyof SelectableUserFrontendExclusive, sortDirection: SortDirection): SET_sortByKeyAction {
  return {
    type: ActionType.SET_sortByKey,
    sortByKey,
    sortDirection
  }
}


export function setAllActivatedUsersUiIsSelected(isSelected: boolean): SET_all_activatedUsers_uiIsSelectedAction {
  return {
    type: ActionType.SET_all_activatedUsers_uiIsSelected,
    isSelected
  }
}

export function loadManageActivatedUsersSite(): AwaitActions {
  return async (dispatch, getState) => {

    dispatch(resetManageActivatedUsersSite())

    //first load system roles
    //then load new users
    await dispatch(getSystemRolesAsync()) //this should ensure the system roles

    const systemRoles = getState().manageActivatedUsersState.systemRoles
    const currentUserId = getState().userDataSettingsSate.userData.id

    dispatch(getActivatedUsersAsync(currentUserId, systemRoles))

  }
}

export function setIsChangeUserDataDialogDisplayed(isDisplayed: boolean): SET_isChangeUserDataDialogDisplayedAction {
  return {
    type: ActionType.SET_isChangeUserDataDialogDisplayed,
    isChangeUserDataDialogDisplayed: isDisplayed
  }
}

export function resetManageActivatedUsersSite(): ResetAction {
  return {
    type: ActionType.RESET
  }
}