/**
 * Created by janis dähne.
 */


import {NewUserFrontendExclusive, UserPreviewFromBackend} from "../../../types/users";
import {
  ResetAction, SET_all_newUsers_uiIsSelectedAction, SET_isLoadingAction, SET_newUser_systemRoleAction,
  SET_newUser_uiIsChangeSystemRolePopupDisplayedAction,
  SET_newUser_uiIsSelectedAction,
  SET_newUsersAction, SET_sortByKeyAction
} from "../../reducers/manageNewUsersSite/manageNewUsersSiteReducer";
import {ActionType,} from '../../reducers/manageNewUsersSite/manageNewUsersSiteActionTypes'
import {SystemRoleFullBase} from "../../../types/userData";
import {AwaitActions} from "../types";
import {getNewUsersAsync, getSystemRolesAsync} from "./manageNewUserSiteCrudActions";
import {SortDirection} from "../../../types/sortDirection";

export function setNewUsers(newUsers: ReadonlyArray<NewUserFrontendExclusive>): SET_newUsersAction {
  return {
    type: ActionType.SET_newUsers,
    newUsers
  }
}

export function setIsLoading(isLoading: boolean): SET_isLoadingAction {
  return {
    type: ActionType.SET_isLoading,
    isLoading
  }
}

export function setSortByKey(sortByKey: keyof NewUserFrontendExclusive, sortDirection: SortDirection): SET_sortByKeyAction {
  return {
    type: ActionType.SET_sortByKey,
    sortByKey,
    sortDirection
  }
}

/**
 *
 * @param {number} newUserId better use id here else we could pass down an old user...
 * @param {boolean} isDisplayed
 * @returns {SET_newUser_uiIsChangeSystemRolePopupDisplayedAction}
 */
export function setNewUserUiIsChangeSystemRolePopupDisplayed(newUserId: number, isDisplayed: boolean): SET_newUser_uiIsChangeSystemRolePopupDisplayedAction {
  return {
    type: ActionType.SET_newUser_uiIsChangeSystemRolePopupDisplayed,
    newUserId,
    isDisplayed
  }
}

export function setNewUserUiIsSelected(newUserId: number, isSelected: boolean): SET_newUser_uiIsSelectedAction {
  return {
    type: ActionType.SET_newUser_uiIsSelected,
    newUserId,
    isSelected
  }
}
export function setAllNewUsersUiIsSelected(isSelected: boolean): SET_all_newUsers_uiIsSelectedAction {
  return {
    type: ActionType.SET_all_newUsers_uiIsSelected,
    isSelected
  }
}

export function setNewUserSystemRole(newUser: NewUserFrontendExclusive, systemRole: SystemRoleFullBase): SET_newUser_systemRoleAction {
  return {
    type: ActionType.SET_newUser_systemRole,
    newUser,
    systemRole
  }
}

export function loadManageNewUsersSite(): AwaitActions {
  return async (dispatch) => {

    dispatch(resetManageNewUsersSite())

    //first load system roles
    //then load new users
    await dispatch(getSystemRolesAsync(true))
    dispatch(getNewUsersAsync())

  }
}

export function resetManageNewUsersSite(): ResetAction {
  return {
    type: ActionType.RESET
  }
}