/**
 * Created by janis dähne.
 */
import {AwaitActions} from "../types";
import {TagFullBase} from "../../../types/tag";
import {ActionType} from "../../reducers/manageTagsSite/manageTagsSiteActionTypes";
import {delay} from "../../../../debug";
import {GET_tagsAction} from "../../reducers/manageTagsSite/getTagsReducer";
import {DELETE_tagAction} from "../../reducers/manageTagsSite/deleteTagReducer";
import {deleteEntity, getTags} from "../../../communicationLayer/tagsLayer";


export function deleteTagAsync(tag: TagFullBase): AwaitActions {
  return async (dispatch) => {
    await dispatch(_deleteSystemRolesAsync(tag))
    dispatch(getTagsAsync())
  }
}

function _deleteSystemRolesAsync(tag: TagFullBase): DELETE_tagAction {
  return {
    type: ActionType.DELETE_tag,
    payload: delay(deleteEntity(tag))
  }
}

export function getTagsAsync(): GET_tagsAction {
  return {
    type: ActionType.GET_tags,
    payload: delay(getTags())
  }
}