/**
 * Created by janis dähne.
 */
import {
  ChangeState, ResetAction, SET_userDataAction,
  SET_userDataChangeStateAction, SET_userSettingsChangeStateAction
} from "../../reducers/settingsSite/settingsSiteReducers";
import {ActionType} from "../../reducers/settingsSite/settingsSiteActionTypes";
import {UserDataFullBase} from "../../../types/userData";
import {AwaitActions, MultiActions} from "../types";
import {setEmail} from "./setUserDataActions";
import {setLangId, setTheme} from "./userSettingsActions";
import {RESET_userDataAction} from "../../reducers/settingsSite/userDataCopyReducer";
import {defaultUserSettings, RESET_userSettingsAction} from "../../reducers/settingsSite/userSettingsCopyReducer";
import {getLangsAsync, getUserSettingsAndDataAsync} from "./userSettingsSiteCrudActions";




export function setUserDataChangeStateAction(changeState: ChangeState): SET_userDataChangeStateAction {
  return {
    type: ActionType.SET_userDataChangeState,
    changeState
  }
}

export function setUserSettingsChangeStateAction(changeState: ChangeState): SET_userSettingsChangeStateAction {
  return {
    type: ActionType.SET_userSettingsChangeState,
    changeState
  }
}



export function setUserData(userData: UserDataFullBase): SET_userDataAction {
  return {
    type: ActionType.SET_userData,
    userData
  }
}

export function setUserDataPartial(userDataAndSettings: UserDataFullBase): MultiActions {
  return (dispatch) => {

    dispatch(setEmail(userDataAndSettings.email))

    dispatch(setLangId(
      userDataAndSettings.settings
        ? userDataAndSettings.settings.langId
        : defaultUserSettings.langId
    ))
    dispatch(setTheme(
      userDataAndSettings.settings
        ? userDataAndSettings.settings.theme
        : defaultUserSettings.theme
    ))

  }
}

export function loadSettingsSite(): AwaitActions {
  return async (dispatch) => {

    //this would clear the credentials --> new login --> bad
    //dispatch(resetUserSettingsSite())

    await dispatch(getLangsAsync())
    await dispatch(getUserSettingsAndDataAsync())
  }
}

export function resetUserSettingsSite(): ResetAction {
  return {
    type: ActionType.RESET
  }
}