/**
 * Created by janis dähne.
 */
import {ActionType} from "../../../../reducers/singleGroupSite/dialogs/addUsers/addsUserDialogActionTypes";
import {
  INVERT_allSelectionsAction, ResetAction,
  SET_all_users_uiIsSelectedAction, SET_sortByKeyAction,
  SET_user_uiIsSelectedAction
} from "../../../../reducers/singleGroupSite/dialogs/addUsers/addUsersDialogReducer";
import {AddableUserFrontendExclusive} from "../../../../../types/users";
import {AwaitActions, MultiActions} from "../../../types";
import {ThunkAction} from "redux-thunk";
import {setIsAddUsersDialogDisplayed} from "../../singleGroupSiteActions";
import {addMembersAsync} from "./addUsersDialogCrudActions";
import {AddUsersToGroupTuplesForBackend} from "../../../../../types/group";
import {getMembersAsync} from "../../singleGroupSiteCrudActions";
import {GroupRoleWithPermissionFullBase} from "../../../../../types/groupRoles";
import {SortDirection} from "../../../../../types/sortDirection";


export function setUserSelected(user: AddableUserFrontendExclusive, isSelected: boolean): SET_user_uiIsSelectedAction {
  return {
    type: ActionType.SET_user_uiIsSelected,
    user,
    isSelected
  }
}

export function setAllUsersSelected(isSelected: boolean): SET_all_users_uiIsSelectedAction {
  return {
    type: ActionType.SET_all_users_uiIsSelected,
    isSelected
  }
}


export function invertAllSelections(): INVERT_allSelectionsAction {
  return {
    type: ActionType.INVERT_allSelections,
  }
}

export function addMembersAndExitAsync(
  groupId: number,
  currentUserId: number,
  groupRoles: ReadonlyArray<GroupRoleWithPermissionFullBase>,
  addUsersTuple: AddUsersToGroupTuplesForBackend): AwaitActions {

  return async (dispatch) => {

    await dispatch(addMembersAsync(addUsersTuple))

    dispatch(getMembersAsync(groupId,currentUserId, groupRoles))
    dispatch(setIsAddUsersDialogDisplayed(false))
    dispatch(resetAddUsersDialog())

  }
}

export function cancelAddUsersDialog(): MultiActions {
  return async (dispatch) => {

    dispatch(setIsAddUsersDialogDisplayed(false))
    dispatch(resetAddUsersDialog())

  }
}

export function setSortByKey(sortByKey: keyof AddableUserFrontendExclusive, sortDirection: SortDirection): SET_sortByKeyAction {
  return {
    type: ActionType.SET_sortByKey,
    sortByKey,
    sortDirection
  }
}

export function resetAddUsersDialog(): ResetAction {
  return {
    type: ActionType.RESET,
  }
}
