/**
 * Created by janis dähne.
 */
import {SystemRoleFullBase} from "../../../types/userData";
import {AwaitActions} from "../types";
import {DELETE_systemRoleAction} from "../../reducers/systemRolesSite/deleteSystemRoleReducer";
import {ActionType} from "../../reducers/systemRolesSite/systemRolesSiteActionTypes";
import {delay} from "../../../../debug";
import {deleteEntity, getSystemRoles} from "../../../communicationLayer/systemRolesLayer";
import {GET_systemRolesAction} from "../../reducers/systemRolesSite/getSystemRolesReducer";


export function deleteSystemRolesAsync(systemRole: SystemRoleFullBase): AwaitActions {
  return async (dispatch) => {
    await dispatch(_deleteSystemRolesAsync(systemRole))
    dispatch(getSystemRolesAsync())
  }
}

function _deleteSystemRolesAsync(systemRole: SystemRoleFullBase): DELETE_systemRoleAction {
  return {
    type: ActionType.DELETE_systemRole,
    payload: delay(deleteEntity(systemRole))
  }
}

export function getSystemRolesAsync(): GET_systemRolesAction {
  return {
    type: ActionType.GET_systemRoles,
    payload: delay(getSystemRoles())
  }
}