/**
 * Created by janis dähne.
 */

import {Action} from "redux";
import {RunnableExerciseTestFrontendExclusive} from "../../../../../types/exerciseEditor";
import {RunnableCustomTestFrontendExclusive} from "../../../../../types/customTests";
import {notExhaustive} from "../../../_notExhausiveHelper";
import {AssessedSubmitTestFromBackend, AssessedSubmitTestFrontendExclusive} from "../../../../../types/testResults";

export type State = {
  readonly isBusy: boolean
  readonly runnableTest: RunnableExerciseTestFrontendExclusive | AssessedSubmitTestFrontendExclusive | null
}

export const initial: State = {
  isBusy: false,
  runnableTest: null
}

export interface ActionBase extends Action {
  readonly type: ActionType
}


export enum ActionType {
  SET_runnableTest = 'viewTestDialogReducer_SET_runnableTest',
  RESET = 'viewTestDialogReducer_RESET',
}


export interface SET_runnableTestAction extends ActionBase {
  readonly type: ActionType.SET_runnableTest
  readonly runnableTest: RunnableExerciseTestFrontendExclusive | AssessedSubmitTestFrontendExclusive | null
}


export interface ResetAction extends ActionBase {
  readonly type: ActionType.RESET
}

export type AllActions =
  ResetAction
  | SET_runnableTestAction


export function reducer(state: State = initial, action: AllActions): State {

  switch (action.type) {

    case ActionType.SET_runnableTest:
      return {
        ...state,
        runnableTest: action.runnableTest

      }
    case ActionType.RESET:
      return initial

    default:
      notExhaustive(action)
      return state
  }
}

