/**
 * Created by janis dähne.
 */
import {ActionBase, ActionType} from "../editCustomProjectSiteActionTypes";
import {State, initial} from "../editCustomProjectSiteReducer";
import {ReduxPromiseAction, ReduxPromiseFulfilledAction, ReduxPromiseRejectedAction} from "../../index";
import {notExhaustive} from "../../_notExhausiveHelper";
import {TestAnswerFromBackend} from "../../../../types/testsAndTestProtocol";


export interface RUN_compileSingleFileCustomProjectAction
  extends ActionBase, ReduxPromiseAction<TestAnswerFromBackend, RUN_compileSingleFileCustomProject_PENDINGAction, RUN_compileSingleFileCustomProject_FULFILLEDAction, RUN_compileSingleFileCustomProject_REJECTEDAction> {
  readonly type: ActionType.RUN_compileSingleFileCustomProject
  readonly payload: Promise<TestAnswerFromBackend>
}

//automatically dispatched by redux promise middleware
export interface RUN_compileSingleFileCustomProject_PENDINGAction
  extends ActionBase {
  readonly type: ActionType.RUN_compileSingleFileCustomProject_PENDING
}

//automatically dispatched by redux promise middleware
export interface RUN_compileSingleFileCustomProject_FULFILLEDAction
  extends ActionBase, ReduxPromiseFulfilledAction<TestAnswerFromBackend> {
  readonly type: ActionType.RUN_compileSingleFileCustomProject_FULFILLED
  readonly payload: TestAnswerFromBackend
}

//automatically dispatched by redux promise middleware
export interface RUN_compileSingleFileCustomProject_REJECTEDAction
  extends ActionBase, ReduxPromiseRejectedAction<void> {
  readonly type: ActionType.RUN_compileSingleFileCustomProject_REJECTED
  readonly payload: any
}


export type AllActions =
  RUN_compileSingleFileCustomProject_PENDINGAction
  | RUN_compileSingleFileCustomProject_FULFILLEDAction
  | RUN_compileSingleFileCustomProject_REJECTEDAction


export function reducer(state: State = initial, action: AllActions): State {

  switch (action.type) {

    case ActionType.RUN_compileSingleFileCustomProject_PENDING:
      return {
        ...state,
        isLoading: true
      }
    case ActionType.RUN_compileSingleFileCustomProject_FULFILLED:
      return {
        ...state,
        isLoading: false,
        lastCompileSingleFileResult: action.payload
      }
    case ActionType.RUN_compileSingleFileCustomProject_REJECTED:
      return {
        ...state,
        isLoading: false,
        lastCompileSingleFileResult: null
      }

    default:
      notExhaustive(action)
      return state
  }
}

