/**
 * Created by janis dähne.
 */

import {ActionBase, ActionType} from "../editCustomProjectSiteActionTypes";
import {initial, State} from "../editCustomProjectSiteReducer";
import {ReduxPromiseAction, ReduxPromiseFulfilledAction, ReduxPromiseRejectedAction} from "../../index";
import {notExhaustive} from "../../_notExhausiveHelper";
import {CustomProjectSolutionFullBase} from "../../../../types/customProjects";


export interface UPDATE_customProjectDescriptionAction
  extends ActionBase, ReduxPromiseAction<void, UPDATE_customProjectDescription_PENDINGAction, UPDATE_customProjectDescription_FULFILLEDAction, UPDATE_customProjectDescription_REJECTEDAction> {
  readonly type: ActionType.UPDATE_customProjectDescription
  readonly payload: Promise<void>
}

//automatically dispatched by redux promise middleware
export interface UPDATE_customProjectDescription_PENDINGAction
  extends ActionBase {
  readonly type: ActionType.UPDATE_customProjectDescription_PENDING
}

//automatically dispatched by redux promise middleware
export interface UPDATE_customProjectDescription_FULFILLEDAction
  extends ActionBase, ReduxPromiseFulfilledAction<void> {
  readonly type: ActionType.UPDATE_customProjectDescription_FULFILLED
  readonly payload: void
}

//automatically dispatched by redux promise middleware
export interface UPDATE_customProjectDescription_REJECTEDAction
  extends ActionBase, ReduxPromiseRejectedAction<void> {
  readonly type: ActionType.UPDATE_customProjectDescription_REJECTED
  readonly payload: any
}


export type AllActions =
  UPDATE_customProjectDescription_PENDINGAction
  | UPDATE_customProjectDescription_FULFILLEDAction
  | UPDATE_customProjectDescription_REJECTEDAction


export function reducer(state: State = initial, action: AllActions): State {

  switch (action.type) {

    case ActionType.UPDATE_customProjectDescription_PENDING:
      return {
        ...state,
        isLoading: true
      }
    case ActionType.UPDATE_customProjectDescription_FULFILLED:
      return {
        ...state,
        isLoading: false,
        initialDescriptionFromBackend: {
          ...state.customProject.description
        },
      }
    case ActionType.UPDATE_customProjectDescription_REJECTED:
      return {
        ...state,
        isLoading: false
      }

    default:
      notExhaustive(action)
      return state
  }
}

