/**
 * Created by janis dähne.
 */
import {notExhaustive} from "../_notExhausiveHelper";
import {ReduxPromiseAction, ReduxPromiseFulfilledAction, ReduxPromiseRejectedAction} from "../index";
import {State, initial} from "./exerciseEditorSiteReducer";
import {
  GET_groups_FULFILLEDAction, GET_groups_PENDINGAction,
  GET_groups_REJECTEDAction
} from "../groupsSite/getGroupsReducer";
import {ActionType} from "../groupsSite/groupsSiteActionTypes";
import Logger from "../../../helpers/logger";


export type AllActions =
  GET_groups_PENDINGAction
  | GET_groups_FULFILLEDAction
  | GET_groups_REJECTEDAction


export function reducer(state: State = initial(), action: AllActions): State {

  switch (action.type) {

    case ActionType.GET_groups_PENDING:
      return {
        ...state,
        isLoading: true
      }
    case ActionType.GET_groups_FULFILLED:
      return {
        ...state,
        isLoading: false,
        groups: action.payload,
        editorExercise: {
          ...state.editorExercise,
          exerciseProperties: {
            ...state.editorExercise.exerciseProperties,
            userGroupId: action.payload.length > 0 ? action.payload[action.payload.length - 1].id : -1 //use length - 1 because 1 will likely the default student group
          }
        }
      }
    case ActionType.GET_groups_REJECTED:
      return {
        ...state,
        isLoading: false,
        groups: []
      }

    default:
      notExhaustive(action)
      return state
  }
}

