/**
 * Created by janis dähne.
 */
import {notExhaustive} from "../_notExhausiveHelper";
import {ReduxPromiseAction, ReduxPromiseFulfilledAction, ReduxPromiseRejectedAction} from "../index";
import {ActionBase, ActionType} from "./editorExerciseSiteActionTypes";
import {initial, State} from "./exerciseEditorSiteReducer";
import Logger from "../../../helpers/logger";


export interface UPDATE_editorExerciseAction
  extends ActionBase, ReduxPromiseAction<void, UPDATE_editorExercise_PENDINGAction, UPDATE_editorExercise_FULFILLEDAction, UPDATE_editorExercise_REJECTEDAction> {
  readonly type: ActionType.UPDATE_editorExercise
  readonly payload: Promise<void>
}

//automatically dispatched by redux promise middleware
export interface UPDATE_editorExercise_PENDINGAction
  extends ActionBase {
  readonly type: ActionType.UPDATE_editorExercise_PENDING
}

//automatically dispatched by redux promise middleware
export interface UPDATE_editorExercise_FULFILLEDAction
  extends ActionBase, ReduxPromiseFulfilledAction<void> {
  readonly type: ActionType.UPDATE_editorExercise_FULFILLED
  readonly payload: void
}

//automatically dispatched by redux promise middleware
export interface UPDATE_editorExercise_REJECTEDAction
  extends ActionBase, ReduxPromiseRejectedAction<void> {
  readonly type: ActionType.UPDATE_editorExercise_REJECTED
  readonly payload: any
}


export type AllActions =
  UPDATE_editorExercise_PENDINGAction
  | UPDATE_editorExercise_FULFILLEDAction
  | UPDATE_editorExercise_REJECTEDAction


export function reducer(state: State = initial(), action: AllActions): State {

  switch (action.type) {

    case ActionType.UPDATE_editorExercise_PENDING:
      return {
        ...state,
        isLoading: true
      }
    case ActionType.UPDATE_editorExercise_FULFILLED:
      return {
        ...state,
        isLoading: false
      }
    case ActionType.UPDATE_editorExercise_REJECTED:
      return {
        ...state,
        isLoading: false
      }

    default:
      notExhaustive(action)
      return state
  }
}

