/**
 * Created by janis dähne.
 */

import {GroupRoleWithPermissionFullBase} from "../../../types/groupRoles";
import {ActionBase, ActionType} from "./groupStorageActionTypes";

import {AllActions as GetUserGroupActions, reducer as getUserGroupRole} from './getUserGroupRole'
import {notExhaustive} from "../_notExhausiveHelper";

export type State = {

  readonly isLoading: boolean

  readonly userGroupRole: GroupRoleWithPermissionFullBase
}


export const initial: State = {
  isLoading: false,
  userGroupRole: null,
}


export interface ResetAction extends ActionBase {
  readonly type: ActionType.RESET
}

export type AllActions =
  ResetAction

  | GetUserGroupActions


export function reducer(state: State = initial, action: AllActions): State {

  switch (action.type) {


    case ActionType.GET_userGroupRole_PENDING:
    case ActionType.GET_userGroupRole_FULFILLED:
    case ActionType.GET_userGroupRole_REJECTED:
      return getUserGroupRole(state, action)

    case ActionType.RESET:
      return initial

    default:
      notExhaustive(action)
      return state
  }
}

