/**
 * Created by janis dähne.
 */
import {ReduxPromiseAction, ReduxPromiseFulfilledAction, ReduxPromiseRejectedAction} from "../index";
import {ActionBase, ActionType} from "./groupsSiteActionTypes";
import {UserGroupFullBase} from "../../../types/group";
import Logger from "../../../helpers/logger";
import {notExhaustive} from "../_notExhausiveHelper";
import {State, initial} from "./groupsSiteReducer";

export interface QUIT_groupAction
  extends ActionBase, ReduxPromiseAction<void, QUIT_group_PENDINGAction, QUIT_group_FULFILLEDAction, QUIT_group_REJECTEDAction> {
  readonly type: ActionType.QUIT_group
  readonly payload: Promise<void>
}

//automatically dispatched by redux promise middleware
export interface QUIT_group_PENDINGAction
  extends ActionBase {
  readonly type: ActionType.QUIT_group_PENDING
}

//automatically dispatched by redux promise middleware
export interface QUIT_group_FULFILLEDAction
  extends ActionBase, ReduxPromiseFulfilledAction<void> {
  readonly type: ActionType.QUIT_group_FULFILLED
  readonly payload: void
}

//automatically dispatched by redux promise middleware
export interface QUIT_group_REJECTEDAction
  extends ActionBase, ReduxPromiseRejectedAction<void> {
  readonly type: ActionType.QUIT_group_REJECTED
  readonly payload: any
}


export type AllActions =
  QUIT_group_PENDINGAction
  | QUIT_group_FULFILLEDAction
  | QUIT_group_REJECTEDAction


export function reducer(state: State = initial, action: AllActions): State {

  switch (action.type) {

    case ActionType.QUIT_group_PENDING:
      return {
        ...state,
        isLoading: true
      }

    case ActionType.QUIT_group_FULFILLED:
      return {
        ...state,
        isLoading: false
      }

    case ActionType.QUIT_group_REJECTED:
      return {
        ...state,
        isLoading: false
      }

    default:
      notExhaustive(action)
      return state
  }
}

