/**
 * Created by janis dähne.
 */
import {notExhaustive} from "../_notExhausiveHelper";
import {ReduxPromiseAction, ReduxPromiseFulfilledAction, ReduxPromiseRejectedAction} from "../index";
import {ActionBase, ActionType} from "./manageCustomProjectsSiteActionTypes";
import {initial, State} from "./manageCustomProjectsSiteReducer";


export interface DELETE_customProjectAction
  extends ActionBase, ReduxPromiseAction<void, DELETE_customProject_PENDINGAction, DELETE_customProject_FULFILLEDAction, DELETE_customProject_REJECTEDAction> {
  readonly type: ActionType.DELETE_customProject
  readonly payload: Promise<void>
}

//automatically dispatched by redux promise middleware
export interface DELETE_customProject_PENDINGAction
  extends ActionBase {
  readonly type: ActionType.DELETE_customProject_PENDING
}

//automatically dispatched by redux promise middleware
export interface DELETE_customProject_FULFILLEDAction
  extends ActionBase, ReduxPromiseFulfilledAction<void> {
  readonly type: ActionType.DELETE_customProject_FULFILLED
  readonly payload: void
}

//automatically dispatched by redux promise middleware
export interface DELETE_customProject_REJECTEDAction
  extends ActionBase, ReduxPromiseRejectedAction<void> {
  readonly type: ActionType.DELETE_customProject_REJECTED
  readonly payload: any
}


export type AllActions =
  DELETE_customProject_PENDINGAction
  | DELETE_customProject_FULFILLEDAction
  | DELETE_customProject_REJECTEDAction


export function reducer(state: State = initial, action: AllActions): State {

  switch (action.type) {

    case ActionType.DELETE_customProject_PENDING:
      return {
        ...state,
        isLoading: true
      }
    case ActionType.DELETE_customProject_FULFILLED:
      return {
        ...state,
        isLoading: false
      }
    case ActionType.DELETE_customProject_REJECTED:
      return {
        ...state,
        isLoading: false
      }

    default:
      notExhaustive(action)
      return state
  }
}

