/**
 * Created by janis dähne.
 */
import {notExhaustive} from "../../../../_notExhausiveHelper";
import {ReduxPromiseAction, ReduxPromiseFulfilledAction, ReduxPromiseRejectedAction} from "../../../../index";
import {ActionBase, ActionType} from "./changeExerciseReleaseDialogActionTypes";
import {initial, State} from "./changeExerciseReleaseDialogReducer";
import Logger from "../../../../../../helpers/logger";
import {ExerciseReleaseFromBackend} from "../../../../../../types/exerciseRelease";

export interface UPDATE_exerciseReleaseAction
  extends ActionBase, ReduxPromiseAction<ExerciseReleaseFromBackend, UPDATE_exerciseRelease_PENDINGAction, UPDATE_exerciseRelease_FULFILLEDAction, UPDATE_exerciseRelease_REJECTEDAction> {
  readonly type: ActionType.UPDATE_exerciseRelease
  readonly payload: Promise<ExerciseReleaseFromBackend>
}

//automatically dispatched by redux promise middleware
export interface UPDATE_exerciseRelease_PENDINGAction
  extends ActionBase {
  readonly type: ActionType.UPDATE_exerciseRelease_PENDING
}

//automatically dispatched by redux promise middleware
export interface UPDATE_exerciseRelease_FULFILLEDAction
  extends ActionBase, ReduxPromiseFulfilledAction<ExerciseReleaseFromBackend> {
  readonly type: ActionType.UPDATE_exerciseRelease_FULFILLED
  readonly payload: ExerciseReleaseFromBackend
}

//automatically dispatched by redux promise middleware
export interface UPDATE_exerciseRelease_REJECTEDAction
  extends ActionBase, ReduxPromiseRejectedAction<void> {
  readonly type: ActionType.UPDATE_exerciseRelease_REJECTED
  readonly payload: any
}


export type AllActions =
  UPDATE_exerciseRelease_PENDINGAction
  | UPDATE_exerciseRelease_FULFILLEDAction
  | UPDATE_exerciseRelease_REJECTEDAction


export function reducer(state: State = initial, action: AllActions): State {

  switch (action.type) {

    case ActionType.UPDATE_exerciseRelease_PENDING:
      return {
        ...state,
        isBusy: true
      }
    case ActionType.UPDATE_exerciseRelease_FULFILLED:
      return {
        ...state,
        isBusy: false
      }
    case ActionType.UPDATE_exerciseRelease_REJECTED:
      return {
        ...state,
        isBusy: false
      }

    default:
      notExhaustive(action)
      return state
  }
}

