/**
 * Created by janis dähne.
 */
import {notExhaustive} from "../../_notExhausiveHelper";
import Logger from "../../../../helpers/logger";
import {ActionType} from '../../manageOwnExercisesSite/ownExercisesSiteActionTypes'
import {
  GET_ownExercises_FULFILLEDAction,
  GET_ownExercises_PENDINGAction, GET_ownExercises_REJECTEDAction,
} from "../../manageOwnExercisesSite/getOwnExercisesReducer";
import {initial, State} from "./submissionsSiteReducer";

//reuse the exercise groups site actions...
//the actions will be handled by the exercise groups site reducer too but we don't care ;)

export type AllActions =
  GET_ownExercises_PENDINGAction
  | GET_ownExercises_FULFILLEDAction
  | GET_ownExercises_REJECTEDAction


export function reducer(state: State = initial, action: AllActions): State {

  switch (action.type) {

    case ActionType.GET_ownExercises_PENDING:
      return {
        ...state,
        isLoading: true
      }
    case ActionType.GET_ownExercises_FULFILLED:
      return {
        ...state,
        isLoading: false,
        exercises: action.payload
      }
    case ActionType.GET_ownExercises_REJECTED:
      return {
        ...state,
        isLoading: false,
        exercises: []
      }

    default:
      notExhaustive(action)
      return state
  }
}

