/**
 * Created by janis dähne.
 */


import {initial, State} from "./singleGroupSiteReducer";
import Logger from "../../../helpers/logger";
import {notExhaustive} from "../_notExhausiveHelper";
import {
  GET_groups_FULFILLEDAction, GET_groups_PENDINGAction,
  GET_groups_REJECTEDAction
} from "../groupsSite/getGroupsReducer";
import {ActionType} from "../groupsSite/groupsSiteActionTypes";


export type AllActions =
  GET_groups_PENDINGAction
  | GET_groups_FULFILLEDAction
  | GET_groups_REJECTEDAction


export function reducer(state: State = initial, action: AllActions): State {

  switch (action.type) {

    case ActionType.GET_groups_PENDING:
      return {
        ...state,
        isLoading: true
      }

    case ActionType.GET_groups_FULFILLED:
      return {
        ...state,
        groups: action.payload,
        //isLoading: false // because this is only the first loading step
      }

    case ActionType.GET_groups_REJECTED:
      return {
        ...state,
        groups: [],
        //isLoading: false // because this is only the first loading step
      }

    default:
      notExhaustive(action)
      return state
  }
}