/**
 * Created by janis dähne.
 */


export enum QuestionType {
  unknown = '???',
  text = 'txt',
  markdown = 'md',
  pdf = 'pdf',
  //currently not supported | 'latex'
  latex = 'latex'

}

export enum AnswerTypes {
  checkboxType = '+',
  radioType = '*',
  textType = 'txt',
}

export interface SurveyData {
//  icon: string
  questions: Question[]
}

export interface Question {

  questionType: string
  question: string

  answersType: string
  possibleAnswers: string[]
}

/**
 * a parse result for an exercise task description
 */
export interface QuestionParseResult {
  /**
   * the occurred errors
   */
  errors: string[]
  /**
   * the result
   */
  result: ExerciseQuestion
}

/**
 * a task description for an exercise (a question)
 */
export interface ExerciseQuestion {
  /*+
  the question type (see ContentTypes)
   */
  questionType: QuestionType
  /**
   * the actual question
   */
  question: string
}

export interface SurveySyntaxParseResult {

  errors: string[]

  result: SurveyData
}


export interface SelectedAnswer {
  wasQuestionAnswered: boolean,
  answers: PreviewAnswer[],
  answerText: string //if the answer type is text (textarea)
}

export interface PreviewAnswer {
  answerText: string,
  isChecked: boolean
}